Ext.define('flextable.Api', {singleton:true, admin:{table:{drop:function(instanceId, tableName) {
  return flextable.Support.newRequest(flextable.Support.basePath + [instanceId, 'admin', 'table', tableName].join('/'), undefined, undefined, 'DELETE').then(function() {
    return true;
  })["catch"](function() {
    return false;
  });
}}}, getConnectionInfo:function(moduleId) {
  return this.getStats(moduleId).then(function(statsObject) {
    return (statsObject || {}).connection;
  });
}, getDriverInfo:function(moduleId, params) {
  params = params === void 0 ? {mode:'driver'} : params;
  return this.loadInfoData(moduleId, params);
}, getTablesViews:function(moduleId, params) {
  params = params === void 0 ? {mode:'tables'} : params;
  return this.loadInfoData(moduleId, params);
}, getTableTypes:function(moduleId, params) {
  params = params === void 0 ? {mode:'tableTypes'} : params;
  return this.loadInfoData(moduleId, params);
}, getSchemas:function(moduleId, params) {
  params = params === void 0 ? {mode:'schemas'} : params;
  return this.loadInfoData(moduleId, params);
}, getCatalogs:function(moduleId, params) {
  params = params === void 0 ? {mode:'catalogs'} : params;
  return this.loadInfoData(moduleId, params);
}, loadInfoData:function(moduleId, params) {
  return flextable.Support.newRequest(flextable.Support.basePath + moduleId + '/info?' + Ext.Object.toQueryString(params), undefined, undefined).then(function(json) {
    json = json || {};
    var meta = json.meta || {};
    return function() {
      var $jscomp$destructuring$var0 = meta;
      var $jscomp$destructuring$var1 = $jscomp$destructuring$var0;
      connection = $jscomp$destructuring$var1.connection;
      return $jscomp$destructuring$var0;
    }();
  }).then(function(statsObject) {
    return (statsObject || {}).connection;
  });
}, getNetworkInfo:function() {
  return flextable.Support.newRequest(flextable.Support.basePath + 'info/net', undefined, undefined).then(function(json) {
    return json || [];
  });
}, getTableMeta:function(moduleId, tableName) {
  return this.loadInfoData(moduleId, {mode:'tableInfo', table:tableName});
}, getStats:function(moduleId, tableName) {
  var params = {};
  if (tableName) {
    params.table = tableName;
  }
  return flextable.Support.newRequest(flextable.Support.basePath + moduleId + '/info?' + Ext.Object.toQueryString(params), undefined, undefined).then(function(json) {
    json = json || {};
    var meta = json.meta || {};
    return function() {
      var $jscomp$destructuring$var2 = meta;
      var $jscomp$destructuring$var3 = $jscomp$destructuring$var2;
      connection = $jscomp$destructuring$var3.connection;
      return $jscomp$destructuring$var2;
    }();
  });
}});
Ext.define('flextable.mixins.Component', {getTooltipConfig:function(tooltip) {
  return {tooltip:tooltip, style:{pointerEvents:'all'}};
}, addTooltipConfig:function(tooltipCfg) {
  this.tabConfig = tooltipCfg;
}, TR:function(key) {
  return flextable.Support.TR(key);
}, faIcon:function(cls) {
  return flextable.Support.faIcon(cls);
}, isDatabaseInstance:function() {
  return flextable.Support.isDatabaseInstance(this.moduleId);
}, copyToClipBoard:function(value, cmp) {
  cmp = cmp || this;
  return flextable.Support.copyToClipBoard(value, cmp);
}, copyWithNotification:function(value, cmp) {
  if ((value || '').length > 0 && this.copyToClipBoard(value, cmp)) {
    BpcCommon.Api.showNotification(value + ' ' + this.TR('COPIED_SUCCESS'));
  }
}, iconForMime:function(mime) {
  mime = mime === void 0 ? '' : mime;
  var mimeCls = flextable.Support.mimeTypeMap[mime] || 'fa-file';
  return this.faIcon(mimeCls);
}, messagePanel:function(messageKey, messageDetailsKey, cfg) {
  cfg = cfg === void 0 ? {} : cfg;
  return Ext.apply({xtype:'flextableMessagePanel', messageKey:messageKey, messageDetailsKey:messageDetailsKey}, cfg || {});
}, _split:function() {
  return {xtype:'splitter'};
}, _padArray:function(elem, arr) {
  return arr.flatMap(function(x) {
    return [elem, x];
  }).slice(1);
}, askAsync:function(titleKey, messageKey) {
  titleKey = titleKey === void 0 ? '' : titleKey;
  messageKey = messageKey === void 0 ? '' : messageKey;
  return flextable.Module.asyncMessageBox(titleKey, messageKey);
}, notification:function(text) {
  BpcCommon.Api.showNotification(text);
}});
Ext.define('flextable.widget.Base', {extend:'Ext.panel.Panel', mixins:['BpcCommon.mixin.Widget', 'flextable.mixins.Component'], layout:'card', initComponent:function() {
  try {
    this.initWidgetSettings();
  } catch (e) {
  }
  this.callParent(arguments);
  this.initWidget();
  this.setSettingPanel();
}, setSettingPanel:function() {
  this.settingPanel = this.add({xtype:'bpcSettingPanel', settings:this.settingStore, buttons:[{text:this.TR('OK'), handler:this.configureWidget.bind(this)}]});
}, initWidget:function() {
  var wrapperComponent = this.createWrapperComponent();
  this.wrapper = wrapperComponent;
  this.add(wrapperComponent);
}, refreshWidget:function() {
  this.wrapper.load();
}, configureWidget:function() {
  this.getLayout().setActiveItem(this.settingPanel.isVisible(true) ? this.wrapper : this.settingPanel);
}});
Ext.define('flextable.widget.Wrapper', {extend:'flextable.widget.Base', alias:'widget.flextableWidget', statics:{WIDGET_NAME:'FLEXTABLE_WIDGET', WIDGET_DESCRIPTION:'FLEXTABLE_WIDGET_DESCRIPTION', WIDGET_ICON_CLS:'x-fal fa-table'}, widgetConfigSettingMap:{moduleId:{settingType:'moduleInstance'}}, config:{widgetConfiguration:{moduleId:undefined}}, moduleId:undefined, createWrapperComponent:function() {
  try {
    var wrapperComponentConfig;
    if (this.moduleId) {
      wrapperComponentConfig = {xtype:'flextableMain', moduleId:this.moduleId, isBpcModule:false, showToolbars:false};
    } else {
      wrapperComponentConfig = this.messagePanel('CONFIG_ISSUE', 'CONFIG_ISSUE_MODULEID_MISSING', {load:Ext.emptyFn()});
    }
    return Ext.create(wrapperComponentConfig);
  } catch (e) {
    return Ext.create(this.messagePanel('UNEXPECTED_ERROR', 'UNEXPECTED_ERROR', {load:Ext.emptyFn()}));
  }
}});
Ext.define('flextable.widget.UtilsWidget', {extend:'flextable.widget.Base', alias:'widget.flextableWidget', statics:{WIDGET_NAME:'FLEXTABLE_WIDGET', WIDGET_DESCRIPTION:'FLEXTABLE_WIDGET_DESCRIPTION', WIDGET_ICON_CLS:'x-fal fa-table'}, moduleId:undefined, createWrapperComponent:function() {
  try {
    return Ext.create({xtype:'flextableConfigNetwork'});
  } catch (e) {
    return Ext.create(this.messagePanel('UNEXPECTED_ERROR', 'UNEXPECTED_ERROR', {load:Ext.emptyFn()}));
  }
}});
Ext.define('flextable.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['flextable.widget.Wrapper', 'flextable.widget.UtilsWidget'], config:{moduleConfigurationComponents:['flextableConfigMain', 'flextableConfigNetwork'], requiredLibraries:['Ace', 'Vkbeautify'], widgets:['flextable.widget.Wrapper']}});
Ext.define('flextable.Module', {singleton:true, mixins:['BpcCommon.mixin.BpcModuleUtilsMixin'], constructor:function() {
  BpcCommon.Api.onReady(this.bootstrapFlextable.bind(this));
}, documentsAvailable:false, bootstrapFlextable:function() {
  var $jscomp$this = this;
  var modulesToLoad = ['documents'];
  var modulesAvailablePromises = modulesToLoad.map(function(moduleName) {
    return $jscomp$this.loadAnotherModule(moduleName);
  });
  Promise.all(modulesAvailablePromises).then(function(array) {
    var notLoaded = array.filter(function(i) {
      return i !== true;
    });
    $jscomp$this.documentsAvailable = notLoaded.length <= 0;
    return $jscomp$this.documentsAvailable;
  }).then(function(docsAvailable) {
    if (docsAvailable) {
      flextable.Support.mimeTypeMap['message/rfc822'] = 'fa-envelope';
      flextable.Support.mimeTypeMap['application/zip'] = 'fa-file-archive';
    }
  }).then(function() {
    flextable.util.CSS.createCustomStyling();
    Ext.defer(function() {
      $jscomp$this.loadLibraries();
    }, 1000);
  });
}, loadAnotherModule:function(moduleName) {
  if (window && window[moduleName]) {
    return Promise.resolve(true);
  } else {
    var baseModule = BpcCommon.Api.getBaseModuleIdById(moduleName);
    if (baseModule === moduleName) {
      return new Promise(function(resolve) {
        BpcCommon.Api.loadModule(moduleName).then(function(success) {
          resolve(true);
        }, function(error) {
          resolve(false);
        });
      });
    }
    return Promise.resolve(false);
  }
}, splitValueRenderer:function() {
  return function(value, metaData, record) {
    try {
      if (value && Ext.isDefined(value) && Ext.isString(value)) {
        var array = value.split(',');
        if (array.length > 0) {
          if (array.length > 1) {
            value = array.length + ' Belege';
          }
          var tooltip = '';
          Ext.Array.each(array, function(string) {
            if (array.length === 1) {
              value = string;
            }
            tooltip += string + '\x3cbr\x3e';
          });
          if (metaData) {
            metaData.tdAttr = "data-qtip\x3d'" + tooltip + "'";
          }
        }
      }
      return value;
    } catch (e) {
      console.error('renderer error', e);
      return 'renderer error';
    }
  };
}, special_multi_icon:function() {
  var $jscomp$this = this;
  return function(v, m, r, rI, cI, store, view) {
    try {
      if (view) {
        var grid = view.up();
        if (grid) {
          var $jscomp$destructuring$var4 = grid;
          var moduleId = $jscomp$destructuring$var4.moduleId;
          var overWriteIconOnly = false;
          if (!moduleId) {
            moduleId = BpcCommon.Api.getActiveModuleId();
            overWriteIconOnly = true;
          }
          var flextableOrMonitor = BpcCommon.Api.getBaseModuleIdById(moduleId);
          var map;
          if (flextableOrMonitor === 'flextable') {
            var uiConfiguration = BpcCommon.Api.getSetting(moduleId, 'uiConfiguration') || {};
            var $jscomp$destructuring$var5 = uiConfiguration;
            var renderer = $jscomp$destructuring$var5.renderer;
            map = renderer || {};
          } else {
            map = BpcCommon.Api.getSetting(moduleId, 'column_customRenderer') || {};
          }
          var lowerCaseRendererMap = {};
          var lowerCaseRendererKeys = Object.keys(map).map(function(k) {
            var lcRendererName = k.toLowerCase();
            lowerCaseRendererMap[lcRendererName] = map[k] || {iconOnly:true, valueMap:{}};
            return lcRendererName;
          });
          v = v || '';
          var stringArray = v.toLowerCase().split('_');
          var toolTip = [];
          if (stringArray.length % 2 === 0) {
            var rendererArray = [];
            stringArray.map(function(v, index, array) {
              if ((index + 1) % 2 === 0) {
                rendererArray.push({key:array[index - 1], value:v});
              }
            });
            var texts = [];
            rendererArray = rendererArray.map(function(obj) {
              if (lowerCaseRendererMap[obj.key]) {
                var rendererConfig = lowerCaseRendererMap[obj.key];
                var $jscomp$destructuring$var6 = rendererConfig;
                var valueMap = $jscomp$destructuring$var6.valueMap;
                valueMap = valueMap || {};
                if (valueMap[obj.value]) {
                  var valueConfig = valueMap[obj.value] || {};
                  var $jscomp$destructuring$var7 = valueConfig;
                  var iconCls = $jscomp$destructuring$var7.iconCls;
                  var color = $jscomp$destructuring$var7.color;
                  var label = $jscomp$destructuring$var7.label;
                  var tt = {};
                  tt[obj.key] = obj.value;
                  toolTip.push(tt);
                  var rendererText = label || (obj.key || '').toUpperCase() + ' ' + obj.value;
                  texts.push(rendererText);
                  return BpcCommon.util.Icons.getSpanForIconCls(iconCls, color);
                }
                return '-1';
              } else {
                return '-1';
              }
            });
            m.tdAttr = "data-qtip\x3d'" + $jscomp$this.arrayToHtmlTable(toolTip) + "'";
            return rendererArray.join('\x26nbsp;') + (overWriteIconOnly ? ' ' + texts.join(' / ') : '');
          } else {
            return v;
          }
        }
      }
      return v;
    } catch (e) {
      console.error('renderer error', e);
      return 'renderer error';
    }
  };
}, objToTableRow:function(obj, width) {
  obj = obj === void 0 ? {} : obj;
  width = width === void 0 ? '150px' : width;
  return Object.keys(obj).map(function(k) {
    return ['\x3ctr\x3e', '\x3ctd\x3e', k, '\x3c/td\x3e', '\x3ctd style\x3d"width: ' + width + ';"\x3e', obj[k], '\x3c/td\x3e', '\x3c/tr\x3e'].join('');
  }).join('');
}, arrayToHtmlTable:function(array, width) {
  var $jscomp$this = this;
  array = array === void 0 ? [] : array;
  width = width === void 0 ? '200px' : width;
  return ['\x3ctable style\x3d"width: ' + width + ';"\x3e', array.map(function(item) {
    return $jscomp$this.objToTableRow(item);
  }).join(''), '\x3c/table\x3e'].join('');
}, asyncMessageBox:function(titleKey, messageKey) {
  titleKey = titleKey === void 0 ? '' : titleKey;
  messageKey = messageKey === void 0 ? '' : messageKey;
  var title = flextable.Support.TR(titleKey);
  var message = flextable.Support.TR(messageKey);
  return new Promise(function(resolve) {
    Ext.Msg.show({title:title, message:message, buttons:Ext.Msg.YESNO, icon:Ext.Msg.QUESTION, fn:function(btn) {
      if (btn === 'yes') {
        resolve(true);
      } else if (btn === 'no') {
        resolve(false);
      } else {
        resolve(undefined);
      }
    }});
  });
}});
Ext.define('flextable.Support', {singleton:true, mixins:['BpcCommon.mixin.BpcModuleUtilsMixin', 'BpcCommon.mixins.Support'], keys:{cfg:'uiConfiguration', id:'idColumn'}, icons:{instance:'fa-th-list', module:'fa-th-list'}, basePath:'cxf/bpc-flextable/', faIcon:function(cls) {
  return BpcCommon.util.Icons.getBpcIconCls(cls);
}, defaultFontSize:14, defaultFontUnit:'px', fallbackIconColor:'#eee', marginRight:3, delay:function(time) {
  time = time === void 0 ? 1000 : time;
  return new Promise(function(resolve) {
    return setTimeout(resolve, time);
  });
}, isDatabaseInstance:function(moduleId) {
  var mainConnection = BpcCommon.Api.getSetting(moduleId, 'mainConnection') || '';
  if (mainConnection.trim() === 'backendConnectionHttp') {
    return false;
  }
  return true;
}, openUrl:function(url) {
  window.open(url, '_blank');
}, isAdmin:function() {
  return BpcCommon.Api.hasUserAnyRole(['bpcadmin']);
}, isDbAdmin:function() {
  return BpcCommon.Api.hasUserAnyRole([BpcCommon.Api.getSetting('flextable', 'db_admin_role')]);
}, isDeveloper:function() {
  return BpcCommon.Api.hasUserAnyRole(['ft-developer', 'flextable-developer']);
}, isLegacyIconCls:function(fontAwesomeName) {
  var iconClasses = fontAwesomeName.split(' ');
  return iconClasses.length > 0 && iconClasses.indexOf('fa') !== -1;
}, detailsEnabled:function(moduleId) {
  var detailsTable = BpcCommon.Api.getSetting(moduleId, 'tableNameDetails') || '';
  return detailsTable && detailsTable.length > 0;
}, getResponseObject:function(response) {
  response = response === void 0 ? {} : response;
  var $jscomp$destructuring$var8 = response || {};
  var responseText = $jscomp$destructuring$var8.responseText;
  var responseJson = $jscomp$destructuring$var8.responseJson;
  if (responseText) {
    return Ext.decode(responseText, true);
  } else if (responseJson) {
    return responseJson;
  }
}, errorWindow:function(errorJson) {
  var $jscomp$destructuring$var9 = errorJson || {};
  var error = $jscomp$destructuring$var9.error;
  var message = $jscomp$destructuring$var9.message;
  var details = $jscomp$destructuring$var9.details;
  details = details || {};
  error = error || ' -1 ';
  message = message || ' -1 ';
  var $jscomp$destructuring$var10 = details || {};
  var stacktrace = $jscomp$destructuring$var10.stacktrace;
  Ext.create('Ext.window.Window', {title:'Flextable Error Window', height:document.body.clientHeight * 0.8, width:document.body.clientWidth * 0.6, layout:'fit', items:[{xtype:'fieldset', title:'Error', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'textfield', fieldLabel:'MESSAGE', value:message}, {xtype:'textarea', grow:true, flex:1, fieldLabel:'STACKTRACE', value:stacktrace || 'NO STACKTRACE AVAILABLE'}]}]}).show();
}, getSpanForIconCls:function(iconCls, color, size) {
  var legacy = this.isLegacyIconCls(iconCls);
  iconCls = this.faIcon(iconCls);
  size = size || this.defaultFontSize;
  size += this.defaultFontUnit;
  color = color || this.fallbackIconColor;
  var marginRight = this.marginRight;
  var style = 'color:' + color + ';' + (legacy ? '' : 'font-size:' + size + ';') + 'margin-right:' + marginRight + ';';
  return '\x3cspan class\x3d"' + iconCls + '" style\x3d"' + style + '"\x3e\x3c/span\x3e';
}, newRequest:function(url, params, data, method) {
  params = params === void 0 ? {} : params;
  data = data === void 0 ? null : data;
  method = method === void 0 ? 'GET' : method;
  return new Promise(function(resolve, reject) {
    Ext.Ajax.request({url:url, params:params, method:method, jsonData:data, headers:{'Content-Type':'application/json'}, success:function(response) {
      resolve(flextable.Support.getResponseObject(response));
    }, failure:function(response) {
      reject(response);
    }});
  });
}, getWindow:function(title, iconCls, width, height, cmpAlias, cmpConfig) {
  var w = Ext.create('Ext.window.Window', {title:title || '', height:height || document.body.clientHeight * 0.8, width:width || document.body.clientWidth * 0.6, layout:'fit', iconCls:flextable.Support.faIcon(iconCls || 'fa-info')});
  cmpConfig = cmpConfig || {};
  cmpConfig.windowReference = w;
  cmpConfig.closeWindow = function() {
    w.close();
  };
  w.add(Ext.create(Ext.apply({xtype:cmpAlias}, cmpConfig)));
  return w;
}, resourcesBasePath:'/bpc-fe-flextable/', getAjaxPromise:function(requestOptions) {
  return new Promise(function(resolve, reject) {
    Ext.Ajax.request(requestOptions).then(function(response) {
      resolve(response);
    }, function(error) {
      reject(error);
    });
  });
}, copyToClipBoard:function() {
  var arguments = $jscomp.getRestArguments.apply(0, arguments);
  return flextable.util.Clipboard.copyToClp.apply(flextable.util.Clipboard, arguments);
}, getBackendConnectionId:function(instanceId) {
  return BpcCommon.Api.getSetting(instanceId, 'proxyId');
}, mimeTypeMap:{'application/pdf':'fa-file-pdf', 'text/plain':'fa-file-alt', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document':'fa-file-word', 'application/xml':'fa-file-code', 'text/xml':'fa-file-code', 'application/edifact':'fa-file-code', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet':'fa-file-excel', 'other':'fa-file'}, objectToHtmlTable:function(obj, keys, trPrefix) {
  keys = keys === void 0 ? [] : keys;
  trPrefix = trPrefix === void 0 ? '' : trPrefix;
  obj = obj || {};
  var html = '\x3ctable style\x3d"width: 300px"\x3e';
  Object.keys(obj).filter(function(k) {
    return keys.length ? keys.indexOf(k) !== -1 : true;
  }).map(function(k) {
    html += '\x3ctr\x3e';
    html += '\x3ctd style\x3d"width: 120px"\x3e' + (trPrefix.length ? flextable.Support.TR(trPrefix + k) : k) + '\x3c/td\x3e';
    html += '\x3ctd style\x3d"width: 180px"\x3e' + obj[k] + '\x3c/td\x3e';
    html += '\x3c/tr\x3e';
  });
  return html + '\x3c/table\x3e';
}, getPluginSourceModuleNames:function() {
  var cfg = BpcCommon.Api.getSetting('flextable', 'plugin_configuration') || [];
  var sourceModuleNames = cfg.filter(function(cfg) {
    return Ext.isDefined(cfg.sourceModule) && cfg.sourceModule !== null;
  }).map(function(cfg) {
    return cfg.sourceModule;
  });
  return Ext.Array.unique(sourceModuleNames);
}, preloadPluginModules:function(moduleId) {
  var $jscomp$this = this;
  var sourceModuleNames = this.getPluginSourceModuleNames();
  var pluginSettingValuesForModuleId = moduleId ? this.getPlugins(moduleId) : [];
  if (this.pluginMap[moduleId]) {
    return Promise.resolve(JSON.parse(JSON.stringify(this.pluginMap[moduleId])));
  } else {
    var moduleLoadPromises = sourceModuleNames.map(function(moduleName) {
      return BpcCommon.Api.loadModule(moduleName);
    });
    return new Promise(function(resolve) {
      Promise.all(moduleLoadPromises).then(function() {
        $jscomp$this.pluginMap[moduleId] = pluginSettingValuesForModuleId;
        resolve(pluginSettingValuesForModuleId);
      }, function() {
        resolve(false);
      });
    });
  }
}, pluginMap:{}, pluginsLoaded:false, getPlugins:function(instanceId) {
  return (this.getModuleSetting('plugin_configuration') || []).filter(function(conf) {
    return Ext.isDefined(conf.targetInstance) && Ext.isArray(conf.targetInstance) && conf.targetInstance.indexOf(instanceId) !== -1;
  });
}});
Ext.define('flextable.mixins.GridUtils', {handleVirtualId:function() {
  var virtualIdConfig = BpcCommon.Api.getSetting(this.moduleId, 'virtualIdConfig') || {};
  var $jscomp$destructuring$var11 = virtualIdConfig;
  var enabled = $jscomp$destructuring$var11.enabled;
  var referenceColumn = $jscomp$destructuring$var11.referenceColumn;
  var sort = $jscomp$destructuring$var11.sort;
  var convert = $jscomp$destructuring$var11.convert;
  if (enabled) {
    if (referenceColumn && referenceColumn.length) {
      this.createVirtualId = true;
      sort = sort || 'ASC';
      this.virtualIdConfig = {referenceColumn:referenceColumn, sort:sort, convert:convert};
    }
  }
}, createVirtualIds:function(records) {
  records = records === void 0 ? [] : records;
  var $jscomp$destructuring$var12 = this.virtualIdConfig || {};
  var referenceColumn = $jscomp$destructuring$var12.referenceColumn;
  var sort = $jscomp$destructuring$var12.sort;
  var convert = $jscomp$destructuring$var12.convert;
  records.sort(function(a, b) {
    var vA = a.get(referenceColumn);
    var vB = b.get(referenceColumn);
    if (convert) {
      vA = parseInt(vA);
      vB = parseInt(vB);
    }
    return vA - vB;
  });
  if (sort !== 'ASC') {
    records.reverse();
  }
  records.map(function(r, i) {
    r.set('flexVirtualId', i + 1);
  });
}, getMetaItem:function(dataIndex) {
  return (this.store.columnsMetaObj || {})[dataIndex];
}, handleGridMenu:function(grid) {
  var $jscomp$this = this;
  var menu = grid.headerCt.getMenu();
  var menuItem = menu.add({text:this.TR('COLUMN_DETAILS'), hidden:!flextable.Support.isDeveloper(), iconCls:this.faIcon('info'), activeDataIndex:null, handler:function(item) {
    var title = flextable.Support.TR('COLUMN_DETAILS') + item.activeDataIndex;
    var w = flextable.Support.getWindow(title, 'fa-info', undefined, undefined, 'panel', {html:flextable.Support.objectToHtmlTable($jscomp$this.getMetaItem(item.activeDataIndex))});
    w.show();
  }});
  menu.on('beforeshow', function() {
    var $jscomp$destructuring$var13 = menu.activeHeader || {};
    var dataIndex = $jscomp$destructuring$var13.dataIndex;
    menuItem.activeDataIndex = dataIndex;
  });
}});
Ext.define('flextable.components.BaseRemoteGrid', {extend:'Ext.grid.Panel', alias:'widget.flextableBaseGrid', mixins:['flextable.mixins.GridUtils', 'flextable.mixins.Component'], moduleId:undefined, columns:undefined, idKey:undefined, flexContext:undefined, fileActionsHidden:true, detailPopUpEnabled:function() {
  return BpcCommon.Api.getSetting(this.moduleId, 'detailView_popup');
}, openDetailWindow:function(rec) {
  var w = flextable.Support.getWindow(rec.get(BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.id)), undefined, undefined, undefined, 'flextableDetailPanel', {record:rec, moduleId:this.moduleId, moduleInstance:this.moduleInstance});
  w.show();
}, getActionColumn:function() {
  return {xtype:'actioncolumn', width:50, items:[]};
}, connectionDetails:{}, getUrl:function() {
  return '';
}, getJsonFromResponse:function(r) {
  return flextable.Support.getResponseObject(r);
}, createStore:function(fields, headers, totalProperty, rootProperty) {
  var $jscomp$this = this;
  fields = fields === void 0 ? [] : fields;
  var proxy = {type:'ajax', url:this.getUrl(), reader:{type:'json', rootProperty:rootProperty || 'items', totalProperty:totalProperty || 'total'}, listeners:{exception:function(p, response, operation) {
    var $jscomp$destructuring$var14 = response || {};
    var timedout = $jscomp$destructuring$var14.timedout;
    var status = $jscomp$destructuring$var14.status;
    var statusText = $jscomp$destructuring$var14.statusText;
    if (timedout) {
      return;
    }
    var json = $jscomp$this.getJsonFromResponse(response);
    if ($jscomp$this.isInubitMonitoringRequest) {
      if (json === null) {
        json = {error:['ERROR', status, statusText].join(''), message:response.responseText || ''};
      }
    }
    $jscomp$this.handleError(json);
  }}};
  if (headers) {
    proxy.headers = headers;
  }
  return Ext.create('Ext.data.Store', {fields:fields, proxy:proxy, autoLoad:false, _grid:this, columnsAdded:undefined, listeners:{load:function(store, records, success, operation) {
    try {
      if (success) {
        if ($jscomp$this.createVirtualId) {
          $jscomp$this.createVirtualIds(records);
        }
        var response = operation.getResponse();
        var json = $jscomp$this.getJsonFromResponse(response);
        var $jscomp$destructuring$var15 = json || {};
        var meta = $jscomp$destructuring$var15.meta;
        var $jscomp$destructuring$var16 = meta || {};
        var connection$0 = $jscomp$destructuring$var16.connection;
        var columns = $jscomp$destructuring$var16.columns;
        if (connection$0) {
          $jscomp$this.connectionDetails = connection$0;
        }
        if (!store.columnsAdded) {
          $jscomp$this.setColumnsFromRecord(records.length ? records[0] : Ext.create('Ext.data.Model', {NO_DATA:undefined}), columns);
        }
        try {
          $jscomp$this.updateTotal();
        } catch (e) {
          console.error('Error updating total btn', e);
        }
      } else {
        if (!store.columnsAdded) {
          $jscomp$this.setColumnsFromRecord(Ext.create('Ext.data.Model', {NO_DATA:undefined}));
        }
      }
    } catch (e$1) {
      console.error('Unexpected load error', e$1);
    }
  }}});
}, createTotalButton:function() {
  var $jscomp$this = this;
  return Ext.create({xtype:'button', iconCls:this.faIcon('fa-database'), text:'0', listeners:{afterRender:function(b) {
    if (flextable.Support.isAdmin()) {
      Ext.create({xtype:'tooltip', target:b, listeners:{beforeshow:function(tip) {
        tip.setHtml(flextable.Support.objectToHtmlTable($jscomp$this.connectionDetails));
      }}});
    }
  }}});
}, baseRenderer:function(v, m, r) {
  var rendererValue;
  v = v || '';
  if (Ext.isObject(v) || Ext.isArray(v)) {
    rendererValue = JSON.stringify(v, undefined, 4);
  }
  return rendererValue ? rendererValue : v;
}, handleRowDblClick:function(record) {
  if (this.moduleInstance.isBpcModule && this.mode !== 'details' || BpcCommon.Api.getSetting(this.moduleId, 'detailView_popup')) {
    this.openDetailWindow(record);
  } else if (!this.moduleInstance.isBpcModule && this.mode === 'details' && this.getAttachment(record)) {
    this.openAttachment(record);
  }
}, initComponent:function() {
  var $jscomp$this = this;
  this.totalBtn = this.createTotalButton();
  var loadMask = true;
  var $jscomp$destructuring$var17 = this.moduleInstance || {};
  var usedAsPlugin = $jscomp$destructuring$var17.usedAsPlugin;
  var bpcPluginInstance = $jscomp$destructuring$var17.bpcPluginInstance;
  if (usedAsPlugin) {
    var configLoadMask = ((bpcPluginInstance.pluginConfiguration || {}).configuration || {}).loadMask;
    if (typeof configLoadMask !== 'undefined') {
      loadMask = configLoadMask;
    } else {
      if (bpcPluginInstance.isModule('monitor')) {
        loadMask = BpcCommon.Api.getSetting(bpcPluginInstance.pluginParentInstanceId, 'grid_showLoadMask');
      }
    }
  }
  this.viewConfig = {emptyText:this.TR('NO_DATA'), enableTextSelection:true, markDirty:false, loadMask:loadMask};
  if (this.isInubitMonitoringRequest) {
    this.bbar = {xtype:'pagingtoolbar', displayInfo:true};
  } else if (this.moduleInstance.showToolbars) {
    this.bbar = [this.totalBtn, {xtype:'tbfill'}];
  }
  var listeners = {};
  listeners.rowdblclick = function(tableView, record) {
    $jscomp$this.handleRowDblClick(record);
  };
  this.listeners = listeners;
  this.callParent(arguments);
}, getEngineBaseUrl:function() {
  return this.getHttpConnectionBaseUrl('engineConnection', 'engineBasePath');
}, getHttpConnectionBaseUrl:function(connectionSettingId, pathSettingId) {
  var proxyId = BpcCommon.Api.getSetting(this.moduleId, connectionSettingId);
  return BpcCommon.Api.getBackendUrl(proxyId) + BpcCommon.Api.getSetting(this.moduleId, pathSettingId);
}, runAction:function(action, record) {
  var $jscomp$this = this;
  var cfg = BpcCommon.Api.getSetting(this.moduleId, 'actionConfig') || {};
  var urlParams = {}, url = this.getEngineBaseUrl() + BpcCommon.Api.getSetting(this.moduleId, 'actionListener');
  if (cfg.params && Ext.isObject(cfg.params) && !Ext.isEmpty(cfg.params)) {
    urlParams = Ext.apply(urlParams, cfg.params);
  }
  var actionPrefix = BpcCommon.Api.getSetting(this.moduleId, 'actionColumnPrefix');
  actionPrefix = actionPrefix || '';
  actionPrefix = actionPrefix.toLowerCase();
  urlParams[actionPrefix] = action;
  urlParams.buttonId = actionPrefix;
  url += '?' + Ext.Object.toQueryString(urlParams);
  var data = record.data || {};
  data.tablePrefix = BpcCommon.Api.getSetting(this.moduleId, 'tableNameDetails');
  return Ext.Ajax.request({url:url, headers:{ISPortalUser:BpcCommon.Api.getUserName(), 'X-BPC-ModuleId':this.moduleId}, method:'POST', params:data}).then(function(response) {
    var json = $jscomp$this.getJsonFromResponse(response);
    if (json) {
      if (json.success) {
        BpcCommon.Api.showNotification(json.message ? json.message : 'Aktion wurde erfolgreich ausgeführt');
      } else {
        BpcCommon.Api.showNotification(json.message ? json.message : 'Fehler bei der Ausführung der Aktion');
      }
    } else {
      BpcCommon.Api.showNotification('Action: ' + action + ' - Fehler bei der Ausführung - Response Unexpected');
    }
  }, function(response) {
    BpcCommon.Api.showNotification('Action: ' + action + ' - Fehler bei der Ausführung');
  });
}, handleError:function(obj) {
  var $jscomp$destructuring$var18 = obj || {};
  var error = $jscomp$destructuring$var18.error;
  var message = $jscomp$destructuring$var18.message;
  var details = $jscomp$destructuring$var18.details;
  error = error || ' -1 ';
  try {
    this.updateViewWithError(error);
    flextable.Support.errorWindow(obj);
  } catch (e) {
  }
}, updateViewWithError:function(error) {
  var v = this.getView();
  if (v) {
    v.setEmptyText(error || ' - ');
  }
}, getAttachmentDataIndex:function() {
  return BpcCommon.Api.getSetting(this.moduleId, 'fileColumn') || 'REFERENCE';
}, getAttachment:function(record) {
  var fileDataIndex = this.getAttachmentDataIndex();
  fileDataIndex = this.handleCapitalization(fileDataIndex);
  return record.get(fileDataIndex);
}, openAttachment:function(record) {
  var $jscomp$this = this;
  try {
    var r = record;
    var w = this.up('window'), t = undefined, idSuffix = 'fileViewerItemId';
    if (w) {
      t = w.down('tabpanel');
      if (t) {
        var params = flextable.file.getFileParameters(record, this.moduleId);
        var openViewer = t.down('#' + idSuffix + params.childid);
        if (openViewer) {
          t.setActiveTab(openViewer);
          return;
        }
      } else {
        return;
      }
    }
    var v = this.getView();
    v.setLoading(true);
    var wrapper, title = '', openAsTab = !!t;
    flextable.file.getFile(r, this.moduleId).then(function(data) {
      if (data) {
        title = flextable.Support.TR('DOCUMENT_PREVIEW');
        var $jscomp$destructuring$var19 = data.meta || {};
        var childid = $jscomp$destructuring$var19.childid;
        if (childid) {
          var stepId = childid;
          if ($jscomp$this.createVirtualId) {
            stepId = record.get('flexVirtualId');
            data.meta.virtualId = stepId;
          }
          title = flextable.Support.TR('DOCUMENT_FROM_STEP') + ': ' + stepId;
        }
        wrapper = flextable.file.getViewer($jscomp$this.moduleId, data);
        if ($jscomp$this.moduleInstance.fileViewerMetaHidden) {
          wrapper.metaField.setVisible(false);
        }
      } else {
      }
    })["catch"](function(e) {
      title = flextable.Support.TR('REQUEST_ERROR');
      var storeData = ['status', 'statusText', 'responseText'].map(function(k) {
        return {key:flextable.Support.TR('ERROR_INFO_REQUEST_' + k.toUpperCase()), value:e[k] || '-1'};
      });
      if (e.request && e.request.url) {
        storeData.push({key:flextable.Support.TR('ERROR_INFO_REQUEST_URL'), value:e.request.url});
      }
      wrapper = $jscomp$this.getErrorPanel(title, storeData, openAsTab);
    })["finally"](function() {
      v.setLoading(false);
      if (t) {
        t.add(wrapper);
        t.setActiveTab(wrapper);
      } else {
        var iconCls = $jscomp$this.iconForMime(wrapper.getMimeType ? wrapper.getMimeType() : '');
        Ext.create('Ext.window.Window', {title:title, constrainHeader:true, height:document.body.clientHeight * 0.5, width:document.body.clientWidth * 0.7, iconCls:iconCls, layout:'fit', items:[wrapper]}).show();
      }
    });
  } catch (e) {
  }
}, getErrorPanel:function(title, data, openAsTab) {
  data = data === void 0 ? [] : data;
  return Ext.create({xtype:'panel', title:title, header:openAsTab, closable:openAsTab, iconCls:this.faIcon('fa-exclamation-triangle'), layout:'fit', items:[{xtype:'grid', header:false, listeners:{rowdblclick:function(tableView, record) {
    if (flextable.Support.copyToClipBoard(record.get('value'), tableView)) {
      BpcCommon.Api.showNotification(record.get('key') + ' ' + flextable.Support.TR('COPIED_SUCCESS'));
    }
  }}, store:Ext.create('Ext.data.Store', {data:data}), columns:[{dataIndex:'key', text:flextable.Support.TR('KEY'), flex:1, menuDisabled:true}, {dataIndex:'value', text:flextable.Support.TR('VALUE'), flex:3, menuDisabled:true}]}]});
}, respectFileDisplaySize:false, getActionColumnConfig:function(moduleId) {
  var $jscomp$this = this;
  var mimetypeDataIndex = 'MIMETYPE', defaultMimetype = 'application/xml';
  mimetypeDataIndex = this.handleCapitalization(mimetypeDataIndex);
  var fileSizeColumn = BpcCommon.Api.getSetting(moduleId, 'fileSizeColumn') || '';
  var maxFileDisplaySize = BpcCommon.Api.getSetting(moduleId, 'maxFileDisplaySize') || -1;
  this.respectFileDisplaySize = fileSizeColumn.length > 0 && maxFileDisplaySize > 0;
  this.fileSizeColumn = fileSizeColumn;
  this.maxFileDisplaySize = maxFileDisplaySize;
  var items = [{tooltip:flextable.Support.TR('SHOW_DOCUMENT'), scope:this, handler:function(g, r, c, i, e, record) {
    $jscomp$this.openAttachment(record);
  }, isActionDisabled:function(view, rowIndex, colIndex, item, record) {
    var recordIndexAvailable = $jscomp$this.getAttachment(record);
    if ($jscomp$this.respectFileDisplaySize && recordIndexAvailable) {
      var value = record.get($jscomp$this.fileSizeColumn) || -2;
      if (Ext.isString(value)) {
        value = parseInt(value);
      }
      return Ext.isNumber(value) && !isNaN(value) ? $jscomp$this.maxFileDisplaySize < value : true;
    }
    return !recordIndexAvailable;
  }, getClass:function(value, metadata, record) {
    var mimeType = record.get(mimetypeDataIndex) || defaultMimetype;
    return $jscomp$this.iconForMime(mimeType);
  }}, {iconCls:this.faIcon('fa-download'), tooltip:this.TR('DOWNLOAD_DOCUMENT'), handler:function(grid, row, c, i, e, r) {
    try {
      flextable.file.openFile(r, moduleId);
    } catch (e$2) {
      BpcCommon.Api.showNotification($jscomp$this.TR('DOWNLOAD_ERROR'));
    }
  }, isActionDisabled:function(view, rowIndex, colIndex, item, record) {
    return !$jscomp$this.getAttachment(record);
  }}].map(function(i) {
    i.hidden = $jscomp$this.fileActionsHidden || BpcCommon.Api.hasUserRole('FLEXTABLE_NO_FILES');
    return i;
  });
  return [{xtype:'actioncolumn', width:items.filter(function(i) {
    return !i.hidden;
  }).length * 30, items:items}];
}, getDateRenderer:function(dateCfg, dataIndex) {
  dateCfg = dateCfg === void 0 ? {} : dateCfg;
  return function(v, m, r) {
    if (!v) {
      return '';
    }
    try {
      var $jscomp$destructuring$var20 = dateCfg;
      var timezone = $jscomp$destructuring$var20.timezone;
      var formatInput = $jscomp$destructuring$var20.formatInput;
      var format = $jscomp$destructuring$var20.format;
      var rendererValue, date;
      if (!formatInput && !format) {
        rendererValue = flextable.util.Date.autoDateParser(v);
      } else {
        if (timezone) {
          v = r.get(dataIndex + '_STRING');
          v = v.trim() + timezone;
          date = new Date(v);
        } else {
          date = formatInput ? Ext.Date.parse(v, formatInput) : Ext.Date.parse(v);
        }
        if (Ext.isDate(date)) {
          rendererValue = Ext.Date.format(date, format);
        } else {
          rendererValue = flextable.util.Date.stringDateParser(v, format);
        }
      }
      return rendererValue ? rendererValue : v || '';
    } catch (e) {
      console.debug('date error', e);
      return 'date error';
    }
  };
}, createRenderer:function(cfg, dataIndex) {
  var $jscomp$this = this;
  dataIndex = dataIndex === void 0 ? '' : dataIndex;
  var $jscomp$destructuring$var21 = cfg || {};
  var isDate = $jscomp$destructuring$var21.isDate;
  var iconOnly = $jscomp$destructuring$var21.iconOnly;
  var compareLower = $jscomp$destructuring$var21.compareLower;
  var nl2br = $jscomp$destructuring$var21.nl2br;
  var injectHtml = $jscomp$destructuring$var21.injectHtml;
  var valueMap = $jscomp$destructuring$var21.valueMap;
  if (isDate) {
    return this.getDateRenderer(cfg, dataIndex);
  }
  var map = valueMap || {};
  return function(v, m, r) {
    var rendererValue;
    v = v || '';
    var isString = typeof v === 'string';
    v = compareLower && isString ? v.toLowerCase() : v;
    if (isString && map[v]) {
      var item = map[v] || {};
      rendererValue = $jscomp$this.doRender(item, v, iconOnly);
      if (iconOnly) {
        if (m) {
          m.tdAttr = "data-qtip\x3d'" + v + "'";
        }
      }
    } else {
      var jsonItems = Object.keys(map).map(function(rendererName) {
        return map[rendererName] || {};
      }).filter(function(item) {
        return item.isJson;
      });
      var $jscomp$destructuring$var22 = $jscomp.makeIterator(jsonItems.filter(function(item) {
        var $jscomp$destructuring$var23 = item;
        var value = $jscomp$destructuring$var23.value;
        if (typeof value === typeof v) {
          var matches = Object.keys(value).map(function(property) {
            return value[property] === v[property];
          });
          if (matches.length && matches.indexOf(false) === -1) {
            return true;
          }
        }
      }));
      var first = $jscomp$destructuring$var22.next().value;
      if (first) {
        rendererValue = $jscomp$this.doRender(first, v, iconOnly);
        if (iconOnly) {
          if (m) {
            m.tdAttr = "data-qtip\x3d'" + JSON.stringify(v) + "'";
          }
        }
      }
    }
    var renderedData = rendererValue ? rendererValue : v;
    if (nl2br) {
      renderedData = injectHtml ? Ext.util.Format.nl2br(renderedData) : renderedData.split('\n').map(function(s) {
        return Ext.String.htmlEncode(s);
      }).join('\x3cbr/\x3e');
    }
    return renderedData;
  };
}, renderIcon:function(cls, c) {
  return cls ? flextable.Support.getSpanForIconCls(cls, c) : undefined;
}, doRender:function(item, v, iconOnly) {
  item = Ext.applyIf(item, {label:undefined, iconOnly:undefined, color:undefined});
  return iconOnly ? this.renderIcon(item.iconCls, item.color) : (this.renderIcon(item.iconCls, item.color) || '') + ' ' + (item.label || v || '');
}, getColumnsFromSetting:function(mainOrDetails) {
  var $jscomp$this = this;
  var cfg = BpcCommon.Api.getSetting(this.moduleId, 'uiConfiguration') || {};
  var rendererCfg = cfg.renderer || {};
  if (cfg[mainOrDetails] && cfg[mainOrDetails].columns) {
    if (cfg[mainOrDetails].fileActionsHidden) {
      this.fileActionsHidden = true;
    }
    return cfg[mainOrDetails].columns.map(function(colCfg) {
      try {
        var $jscomp$destructuring$var24 = colCfg;
        var dataIndex$3 = $jscomp$destructuring$var24.dataIndex;
        var targetDataIndex = $jscomp$this.handleCapitalization(dataIndex$3);
        if (colCfg.renderer) {
          if (typeof colCfg.renderer === 'string') {
            if (colCfg.renderer.startsWith('FT_DATE')) {
              var renderer = $jscomp$this.createRenderer({isDate:true}, targetDataIndex);
              if (renderer) {
                colCfg.renderer = renderer;
              }
            } else if (flextable.Module[colCfg.renderer]) {
              colCfg.renderer = flextable.Module[colCfg.renderer]();
            }
          }
        } else {
          var renderer$4 = dataIndex$3 && rendererCfg[dataIndex$3] ? $jscomp$this.createRenderer(rendererCfg[dataIndex$3] || {}, targetDataIndex) : undefined;
          if (renderer$4) {
            colCfg.renderer = renderer$4;
          }
        }
      } catch (e) {
      }
      var $jscomp$destructuring$var25 = colCfg;
      var dataIndex = $jscomp$destructuring$var25.dataIndex;
      var text = $jscomp$destructuring$var25.text;
      var header = $jscomp$destructuring$var25.header;
      var capitalizedDataIndex = $jscomp$this.handleCapitalization(dataIndex);
      colCfg.dataIndex = capitalizedDataIndex;
      if (!text && !header) {
        colCfg.text = capitalizedDataIndex;
      }
      return colCfg;
    });
  }
}, handleCapitalization:function(value) {
  return flextable.util.Database.handleCapitalization(value, this.moduleId);
}, changeExtraParams:function(params) {
  var p = this.store.getProxy().getExtraParams() || {};
  p = Ext.apply(p, params);
  this.store.getProxy().setExtraParams(p);
  this.store.load();
}, setColumnsFromRecord:function(rec, columnsMetaObj) {
  var $jscomp$this = this;
  columnsMetaObj = columnsMetaObj === void 0 ? {} : columnsMetaObj;
  var obj = rec ? rec.getData() : {};
  columnsMetaObj = columnsMetaObj || {};
  var columns = Object.keys(obj).filter(function(name) {
    return name !== 'id';
  }).map(function(name) {
    if (columnsMetaObj[name]) {
      var columnMetaData = columnsMetaObj[name];
      var $jscomp$destructuring$var26 = columnMetaData || {};
      var type = $jscomp$destructuring$var26.type;
      var typeName = $jscomp$destructuring$var26.typeName;
      var types = {93:{inputValue:'time'}, TIMESTAMP:{inputValue:'time'}};
      if (types.hasOwnProperty(type)) {
        var formatInput = types[type].inputValue;
        return $jscomp$this.dateRenderColumnObj(name, formatInput);
      } else if (types.hasOwnProperty(typeName)) {
        var formatInput$5 = types[type].inputValue;
        return $jscomp$this.dateRenderColumnObj(name, formatInput$5);
      }
    }
    return $jscomp$this.baseColumnObj(name);
  });
  this.reconfigure(columns);
  this.store.columnsMetaObj = columnsMetaObj;
  this.store.addColumns = true;
}, dateRenderColumnObj:function(name, formatInput) {
  var defaultDateRendererFormat = 'd.m.Y H.i:s', autoParse = false;
  var cfg = this.baseColumnObj(name);
  cfg.renderer = this.getDateRenderer({format:defaultDateRendererFormat, formatInput:formatInput, autoParse:autoParse}, name);
  return cfg;
}, baseColumnObj:function(name) {
  return {dataIndex:name, text:name.toUpperCase(), flex:1, renderer:this.baseRenderer};
}, updateTotal:function(num) {
  if (this) {
    var total = num || (this.store ? this.store.getTotalCount() : 0) || 0, totalText = String(total) + ' ' + flextable.Support.TR('ROWS');
    if (this.totalBtn) {
      this.totalBtn.setText(totalText);
    } else {
      console.debug('total btn not defined or null');
    }
  } else {
    console.debug('component not defined or null - state critical');
    console.debug('this: ');
    console.debug(this);
  }
}, getPluginDefinitions:function() {
  var h = Ext.createByAlias('widget.flextableGridActionHook', {hidden:true, moduleId:this.moduleId});
  return h.getPluginDefinitions();
}});
Ext.define('flextable.components.DetailPanel', {extend:'Ext.panel.Panel', alias:'widget.flextableDetailPanel', layout:{type:'vbox', align:'stretch'}, header:false, initComponent:function() {
  this.callParent(arguments);
  this.createMainComponents();
  this.addComponentContent();
}, createMainComponents:function() {
  var defaults = {record:this.record, moduleInstance:this.moduleInstance};
  var containerBase = {xtype:'container', layout:'fit', items:[], flex:1};
  this.topContainer = Ext.create(Ext.apply({}, containerBase, defaults));
  this.mainContainer = Ext.create(Ext.apply({}, containerBase, defaults));
  this.add([this.topContainer, {xtype:'splitter'}, this.mainContainer]);
}, addProcessViewer:function() {
  var processViewerCmp = this.topContainer.add(Ext.apply({xtype:'flextableProcessViewer', header:false}, {record:this.record, moduleInstance:this.moduleInstance}));
}, addDetailGrid:function() {
  var tabPanel = this.mainContainer._mainView;
  var detailGrid = tabPanel.add({xtype:'flextableGrid', moduleId:this.moduleId, moduleInstance:this.moduleInstance, mode:'details', title:flextable.Support.TR('LOG_STEPS')});
  tabPanel.setActiveTab(detailGrid);
  detailGrid.changeExtraParams({id:this.record.get(BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.id))});
  detailGrid.store.load();
}, addComponentContent:function() {
  this.addProcessViewer();
  var tabPanel = this.mainContainer.add({xtype:'tabpanel'});
  this.mainContainer._mainView = tabPanel;
  if (flextable.Support.detailsEnabled(this.moduleId)) {
    this.addDetailGrid();
  }
  this.addBpcPlugins();
}, addBpcPlugins:function() {
  var $jscomp$this = this;
  var hook = Ext.create({xtype:'flextableDetailViewPopup', moduleId:this.moduleId});
  try {
    var pluginDefinitions = hook.getPluginDefinitions();
    (pluginDefinitions || []).map(function(cfg) {
      $jscomp$this.addBpcPlugin(cfg);
    });
  } catch (e) {
    console.debug('error fetching plugins');
  }
}, addBpcPlugin:function(cfg) {
  this.mainContainer._mainView.add(cfg);
  try {
    this.mainContainer._mainView.add(cfg);
  } catch (e) {
    console.debug('error adding plugin', cfg);
  }
}});
Ext.define('flextable.components.DynamicHtmlContent', {extend:'Ext.container.Container', alias:'widget.flextableDynamicHtmlContent', url:'', listeners:{boxready:function(c) {
  c.setHtml('\x3ciframe  width\x3d"100%" height\x3d"100%" src\x3d"' + c.url + '"\x3e\x3c/iframe\x3e');
}}, update:function(htmlOrData, loadScripts, callback, scriptScope) {
  var me = this, isData = me.tpl && !Ext.isString(htmlOrData), container = me.ownerFocusableContainer, sizeModel, doLayout, el;
  if (isData) {
    me.data = htmlOrData && htmlOrData.isEntity ? htmlOrData.getData(true) : htmlOrData;
  } else {
    me.html = Ext.isObject(htmlOrData) ? Ext.DomHelper.markup(htmlOrData) : htmlOrData;
  }
  if (me.rendered) {
    sizeModel = me.getSizeModel();
    doLayout = sizeModel.width.shrinkWrap || sizeModel.height.shrinkWrap;
    if (me.isContainer) {
      el = me.layout.getRenderTarget();
      doLayout = doLayout || me.items.items.length > 0;
    } else {
      el = me.getTargetEl();
    }
    if (isData) {
      me.tpl[me.tplWriteMode](el, me.data || {});
    } else {
      el.setHtml = function(html) {
        if (this.dom) {
          this.dom.innerHTML = html;
        }
        return this;
      };
      el.setHtml(me.html, loadScripts, callback, scriptScope || me);
    }
    if (doLayout) {
      me.updateLayout();
    }
    if (container && !container.onFocusableChildUpdate.$nullFn) {
      container.onFocusableChildUpdate(me);
    }
  }
}, setHtml:function(html, loadScripts, callback, scriptScope) {
  this.update(html, loadScripts, null, scriptScope);
}});
Ext.define('flextable.components.Grid', {extend:'flextable.components.BaseRemoteGrid', alias:'widget.flextableGrid', moduleId:undefined, columns:undefined, idKey:undefined, flexContext:undefined, fileActionsHidden:undefined, connectionDetails:{}, createVirtualId:false, getUrl:function() {
  return 'cxf/bpc-flextable/' + this.moduleId + '/data';
}, initComponent:function() {
  var $jscomp$this = this;
  var listeners = {};
  var fieldsDefinition = [];
  if (this.mode === 'details') {
    var idFieldForDetails = BpcCommon.Api.getSetting(this.moduleId, 'idColumnDetailSub');
    fieldsDefinition.push({name:idFieldForDetails, sortType:'asInt'});
  }
  this.handleVirtualId();
  this.store = this.createStore(fieldsDefinition);
  var definedColumns = this.getColumnsFromSetting(this.mode || 'main');
  var columns = definedColumns ? this.getActionColumnConfig(this.moduleId).concat(definedColumns) : undefined;
  var actionColumn = this.getActionColumn();
  var pluginDefinitions = this.getPluginDefinitions();
  if (pluginDefinitions && pluginDefinitions.length) {
    var instances = pluginDefinitions.map(function(i) {
      return Ext.create(i);
    });
    if (instances.length === 1) {
      var o = instances[0].getPluginAction(this);
      if (o) {
        actionColumn.items.push(o);
      }
    }
  }
  var actionColPrefix = BpcCommon.Api.getSetting(this.moduleId, 'actionColumnPrefix');
  var actionListener = BpcCommon.Api.getSetting(this.moduleId, 'actionListener');
  var actionActive = actionListener !== null && actionListener !== undefined;
  if (actionActive) {
    actionColumn.items.push({iconCls:this.faIcon('fa-play'), tooltip:'Aktionen starten', handler:function(grid, rowIndex, colIndex, item, e, record) {
      var actions = [];
      var actionColumns = Object.keys(record.data).filter(function(i) {
        if (i && Ext.isString(i)) {
          return i.startsWith(actionColPrefix);
        }
        return false;
      }).map(function(name) {
        var actionString = record.get(name);
        actionString.split(',').map(function(i) {
          i = i || '';
          return i.trim();
        }).filter(function(i) {
          return i.length > 0;
        }).map(function(i) {
          actions.push({text:i});
        });
      });
      Ext.create('Ext.menu.Menu', {margin:'0 0 10 0', floating:true, items:actions.map(function(i) {
        i.record = record;
        i.iconCls = $jscomp$this.faIcon('fa-play-circle');
        i.handler = function(m) {
          $jscomp$this.runAction(m.text, m.record);
        };
        return i;
      })}).showAt(e.getXY());
    }, isActionDisabled:function(view, rowIndex, colIndex, item, record) {
      if (record && record.data) {
        var actionColumns = Object.keys(record.data).filter(function(i) {
          if (i && Ext.isString(i)) {
            return i.startsWith(actionColPrefix);
          }
          return false;
        });
        return actionColumns.length === 0;
      }
      return true;
    }});
  }
  if (actionColumn.items.length && columns) {
    actionColumn.width = actionColumn.items.length * 30;
    columns.push(actionColumn);
  }
  this.columns = columns;
  var detailsEnabled = flextable.Support.detailsEnabled(this.moduleId);
  this.plugins = this.idKey && detailsEnabled ? [{ptype:'rowwidget', widget:{xtype:'container', layout:'fit', items:[]}, _grid:this, onWidgetAttach:function(plugin, cmp, record) {
    cmp.removeAll();
    var gridCmp = cmp.add({xtype:'flextableGrid', moduleId:plugin._grid.moduleId, moduleInstance:plugin._grid.moduleInstance, mode:'details'});
    var $jscomp$destructuring$var27 = plugin._grid || {};
    var moduleId = $jscomp$destructuring$var27.moduleId;
    var idKey = $jscomp$destructuring$var27.idKey;
    idKey = gridCmp.handleCapitalization(idKey);
    var pid = record.get(idKey);
    if (pid) {
      gridCmp.changeExtraParams({id:pid});
      gridCmp.store.load();
    }
  }}] : [];
  this.store.columnsAdded = !!(Ext.isDefined(this.columns) && this.columns.length);
  if (!Ext.isDefined(this.columns)) {
    this.columns = [];
  }
  listeners.beforedestroy = function() {
    $jscomp$this.moduleInstanceCleanUp();
  };
  listeners.afterrender = function(grid) {
    $jscomp$this.handleGridMenu(grid);
  };
  this.listeners = listeners;
  this.callParent(arguments);
  this.registerRefreshEvents();
}, moduleInstanceCleanUp:function() {
  try {
    if (this.eventReferenceStore.length) {
      this.eventReferenceStore.map(function(ref) {
        try {
          ref.destroy();
        } catch (e) {
          console.error('ERROR DESTROYING EVENT REF');
        }
      });
    }
  } catch (e) {
    console.error('ERROR REMOVING EVENTS');
  }
}, eventReferenceStore:[], registerRefreshEvents:function() {
  var eventRef = Ext.on({destroyable:true, tableRefresh:this.handleBpcEvent.bind(this)});
  this.eventReferenceStore = [eventRef];
}, handleBpcEvent:function(eventData) {
  var $jscomp$destructuring$var28 = eventData || {};
  var topic = $jscomp$destructuring$var28.topic;
  var properties = $jscomp$destructuring$var28.properties;
  var $jscomp$destructuring$var29 = properties || {};
  var instanceId = $jscomp$destructuring$var29.instanceId;
  topic = topic || '';
  var topicParts = topic.split('/');
  if (topicParts.length === 5 && topicParts[3] === 'flextable' && instanceId === this.moduleId) {
    this.doTableRefresh();
  }
}, doTableRefresh:function() {
  try {
    this.store.load();
  } catch (e) {
    Ext.toast('ERROR LOADING STORE');
  }
}});
Ext.define('flextable.components.HttpGrid', {extend:'flextable.components.BaseRemoteGrid', alias:'widget.flextableHttpGrid', moduleId:undefined, columns:undefined, idKey:undefined, flexContext:undefined, connectionDetails:{}, getUrl:function() {
  return this.getHttpConnectionBaseUrl('backendConnectionHttp', 'backendConnectionHttpBasePath');
}, initComponent:function() {
  var $jscomp$destructuring$var30 = BpcCommon.Api.getSetting(this.moduleId, 'backendConnectionHttpExtraConfig') || {};
  var headers = $jscomp$destructuring$var30.headers;
  var totalProperty = $jscomp$destructuring$var30.totalProperty;
  var rootProperty = $jscomp$destructuring$var30.rootProperty;
  this.store = this.createStore(undefined, headers, totalProperty, rootProperty);
  var $jscomp$destructuring$var31 = BpcCommon.Api.getSetting(this.moduleId, 'uiConfiguration') || {};
  var isInubitMonitoringRequest = $jscomp$destructuring$var31.isInubitMonitoringRequest;
  if (typeof isInubitMonitoringRequest === 'undefined') {
    isInubitMonitoringRequest = (this.getUrl() || '').indexOf('/ibis/rest/log/') !== -1;
  }
  if (isInubitMonitoringRequest) {
    this.isInubitMonitoringRequest = isInubitMonitoringRequest;
    flextable.util.Store.prepareForIS(this.store);
  }
  this.columns = this.getColumnsFromSetting('main') || [];
  this.store.columnsAdded = this.columns.length > 0;
  this.callParent(arguments);
}});
Ext.define('flextable.components.LoadingPanel', {extend:'Ext.panel.Panel', alias:'widget.flextableMessagePanel', mixins:['flextable.mixins.Component'], layout:'fit', messageKey:undefined, messageDetailsKey:undefined, initComponent:function() {
  this.messagePanel = Ext.create({xtype:'container', width:'400', height:'150', html:''});
  this.setMessage();
  this.items = [{xtype:'container', layout:'center', items:[this.messagePanel]}];
  this.callParent(arguments);
}, setMessage:function(icon, color, size) {
  icon = icon === void 0 ? 'fa-file-exclamation' : icon;
  color = color === void 0 ? '#000' : color;
  size = size === void 0 ? 40 : size;
  var message = [];
  message.push('\x3cdiv style\x3d"display: flex; flex-direction: column; justify-content: center; justify-items: center; align-items: center; padding: 30px;"\x3e');
  message.push('\x3cdiv style\x3d"padding: 10px;"\x3e' + BpcCommon.util.Icons.getSpanForIconCls(this.faIcon(icon), color, size) + '\x3c/div\x3e');
  if (this.messageKey) {
    message.push('\x3cdiv style\x3d"padding: 10px;"\x3e' + this.TR(this.messageKey) + '\x3c/div\x3e');
  }
  if (this.messageDetailsKey) {
    message.push('\x3cdiv style\x3d"padding: 10px;"\x3e' + this.TR(this.messageDetailsKey) + '\x3c/div\x3e');
  }
  message.push('\x3c/div\x3e');
  var messageHtml = message.join('').trim();
  this.messagePanel.update(messageHtml);
}});
Ext.define('flextable.file', {singleton:true, getFileParameters:function(record, moduleId) {
  var directoryKey = BpcCommon.Api.getSetting(moduleId, 'fileColumn') || '';
  var processidKey = BpcCommon.Api.getSetting(moduleId, 'idColumnDetail') || '';
  var childidKey = BpcCommon.Api.getSetting(moduleId, 'idColumnDetailSub') || '';
  var mimeKey = BpcCommon.Api.getSetting(moduleId, 'fileMimeColumn') || '';
  directoryKey = flextable.util.Database.handleCapitalization(directoryKey, this.moduleId);
  processidKey = flextable.util.Database.handleCapitalization(processidKey, this.moduleId);
  childidKey = flextable.util.Database.handleCapitalization(childidKey, this.moduleId);
  mimeKey = flextable.util.Database.handleCapitalization(mimeKey, this.moduleId);
  var directory = record.get(directoryKey) || null;
  var processid = record.get(processidKey) || null;
  var childid = record.get(childidKey) || null;
  var mime = record.get(mimeKey) || null;
  var prefix = BpcCommon.Api.getSetting(moduleId, 'tablePrefix') || null;
  return {directory:directory, processid:processid, childid:childid, prefix:prefix, mime:mime};
}, getFileUrl:function(record, moduleId) {
  var params = this.getFileParameters(record, moduleId);
  var proxyId = BpcCommon.Api.getSetting(moduleId, 'engineConnection') || '-1';
  var basePath = BpcCommon.Api.getSetting(moduleId, 'engineBasePath') || '';
  var fileListener = BpcCommon.Api.getSetting(moduleId, 'fileListener') || '';
  var prefix = BpcCommon.Api.getBackendUrl(proxyId) || '';
  return prefix + basePath + fileListener + '?' + Ext.Object.toQueryString(params);
}, buf2hex:function(buffer) {
  return [].concat($jscomp.arrayFromIterable(new Uint8Array(buffer))).map(function(x) {
    return x.toString(16).padStart(2, '0');
  }).join('');
}, textDecoder:undefined, decodeArrayBuffer:function(arrayBuffer) {
  var hex = this.buf2hex(arrayBuffer);
  hex = (hex || '').toLowerCase();
  var bomEncoding;
  if (hex.startsWith('fffe')) {
    bomEncoding = 'utf-16le';
  } else if (hex.startsWith('feff')) {
    bomEncoding = 'utf-16be';
  }
  var textDecoder = new TextDecoder(bomEncoding);
  var text = textDecoder.decode(arrayBuffer);
  return {hex:hex, text:text, bomEncoding:bomEncoding, decodeEncoding:textDecoder.encoding};
}, chunkHexStr:function(data, size) {
  size = size === void 0 ? 16 : size;
  var n = data, hexParts = [];
  while (n.length !== 0) {
    var part = n.slice(0, size);
    hexParts.push(part);
    n = n.slice(size);
  }
  return hexParts;
}, getFile:function(record, moduleId) {
  var $jscomp$this = this;
  var url = this.getFileUrl(record, moduleId);
  return fetch(url).then(function(r) {
    return r.arrayBuffer();
  }).then(function(arrayBuffer) {
    return $jscomp$this.decodeArrayBuffer(arrayBuffer);
  }).then(function(fileObj) {
    var $jscomp$destructuring$var32 = fileObj;
    var text = $jscomp$destructuring$var32.text;
    var hex = $jscomp$destructuring$var32.hex;
    var bomEncoding = $jscomp$destructuring$var32.bomEncoding;
    var decodeEncoding = $jscomp$destructuring$var32.decodeEncoding;
    var meta = flextable.file.getFileParameters(record, moduleId);
    meta.bomEncoding = bomEncoding;
    meta.decodeEncoding = decodeEncoding;
    return {bomEncoding:bomEncoding, file:text, meta:meta, record:record, hex:hex, fileSource:text, fileUrl:url};
  });
}, openFile:function(record, moduleId) {
  flextable.Support.openUrl(this.getFileUrl(record, moduleId));
}, getViewer:function(moduleId, data, idSuffix) {
  data = data === void 0 ? {} : data;
  idSuffix = idSuffix === void 0 ? 'fileViewerItemId' : idSuffix;
  var fileData = data.file || '';
  if (data.meta.mime) {
    data.meta.forceViewUrl = ['image/png', 'image/jpeg', 'image/bmp', 'image/gif', 'image/jpg', 'application/pdf', 'text/xml', 'application/xml'].indexOf(data.meta.mime) !== -1;
    data.meta.isXml = ['text/xml', 'application/xml'].indexOf(data.meta.mime) !== -1 || fileData.trim().startsWith('\x3c');
    if (data.meta.mime === 'application/octet-stream') {
      if (data.meta.directory.endsWith('.pdf')) {
        data.meta.mime = 'application/pdf';
        data.meta.isXml = false;
        data.meta.mimeGuess = true;
      }
      if (data.meta.directory.endsWith('.html')) {
        data.meta.mime = 'text/html';
        data.meta.isXml = true;
        data.meta.mimeGuess = true;
      }
      if (data.meta.directory.endsWith('.json')) {
        data.meta.mime = 'application/json';
        data.meta.isXml = false;
        data.meta.mimeGuess = true;
      }
      if (data.meta.directory.endsWith('.xml')) {
        data.meta.mime = 'text/xml';
        data.meta.isXml = true;
        data.meta.mimeGuess = true;
        data.meta.mimeGuessText = 'via directory ending';
      }
    }
  } else {
    fileData = fileData.trim();
    if (fileData.startsWith('\x3c')) {
      data.meta.mime = 'text/xml';
      data.meta.isXml = true;
      data.meta.mimeGuess = true;
      data.meta.mimeGuessText = 'content starts with \x3c';
    } else if (fileData.split("'").length > 2) {
      data.meta.mime = 'application/edifact';
      data.meta.mimeGuess = true;
      data.meta.mimeGuessText = 'content starts with single quote';
    } else {
    }
  }
  if (data.meta.isXml) {
    if (data.meta.bomEncoding) {
      var xmlEncoding = this.getXmlEncoding(data.fileSource);
      var xmlEncodingLc = (xmlEncoding || '').toLowerCase();
      if (!data.meta.bomEncoding.toLowerCase().startsWith(xmlEncodingLc)) {
        data.hasErrors = true;
        var errorMsg = flextable.Support.TR('ERROR_FILE_DECLARED_ENCODING_MISMATCH');
        data.errors = [{msg:errorMsg, type:'encoding_xml_file'}];
        data.meta.xmlEncoding = xmlEncoding;
        data.meta.encodingIssue = errorMsg;
      }
    }
    data.file = this.formatXml(fileData);
    data.treeView = this.createTreeViewWrapper(data.fileSource);
  } else if (data.meta.mime === 'application/edifact') {
    data.file = fileData.split("'").map(function(i) {
      return i.trim();
    }).join("'\r\n");
  } else {
    if (fileData.split("'").length > 2) {
      data.file = fileData.split("'").map(function(i) {
        return i.trim();
      }).join("'\r\n");
    }
  }
  return this.createViewer({moduleId:moduleId, idSuffix:idSuffix, fileObject:data});
}, getXmlEncoding:function(xmlStr, mime) {
  mime = mime === void 0 ? 'text/xml' : mime;
  var xmlDoc = flextable.util.Data.parseXml(xmlStr, mime);
  var $jscomp$destructuring$var33 = xmlDoc;
  var xmlEncoding = $jscomp$destructuring$var33.xmlEncoding;
  if ((xmlEncoding || '').length === 0) {
    var $jscomp$destructuring$var34 = $jscomp.makeIterator((xmlStr || '').trim().toLowerCase().split('\n'));
    var first = $jscomp$destructuring$var34.next().value;
    first = first || '';
    var firstIndex = first.indexOf('encoding\x3d');
    if (firstIndex !== -1) {
      var ending = first.indexOf('?\x3e');
      if (ending !== -1) {
        var encodingPart = first.substring(firstIndex, ending);
        encodingPart = encodingPart.replaceAll('encoding\x3d', '');
        encodingPart = encodingPart.replaceAll("'", '');
        encodingPart = encodingPart.replaceAll('"', '');
        encodingPart = encodingPart.trim();
        return encodingPart;
      }
    }
  }
  return xmlEncoding;
}, formatXml:function(data) {
  return vkbeautify.xml(data);
}, createTreeViewWrapper:function(fileSource) {
  var $jscomp$this = this;
  return Ext.create({xtype:'panel', header:false, layout:'fit', treeViewInitiated:false, fileSource:fileSource, listeners:{boxready:function(c) {
    try {
      c.setLoading(flextable.Support.TR('CREATING_TREE_VIEW'));
      Ext.defer(function() {
        var t;
        try {
          t = Ext.create({xtype:'ftTree', fileSource:c.fileSource});
          c.treeViewInitiated = true;
        } catch (e) {
          t = $jscomp$this.errorPanel('TREE VIEW ERROR');
          c.treeViewInitiated = false;
        }
        c.setLoading(false);
        c.removeAll();
        c.add(t);
      }, 500);
    } catch (e) {
    }
  }}, items:[{xtype:'container', html:''}]});
}, createViewer:function(cfg) {
  cfg = cfg === void 0 ? {} : cfg;
  var viewer;
  try {
    viewer = Ext.create(Ext.apply({}, {xtype:'ftFileViewer'}, cfg));
    var $jscomp$destructuring$var35 = cfg;
    var fileObject = $jscomp$destructuring$var35.fileObject;
    if (fileObject.hasErrors) {
      var $jscomp$destructuring$var36 = $jscomp.makeIterator(fileObject.errors || []);
      var first = $jscomp$destructuring$var36.next().value;
      viewer.baseViewer.textView.setWarning(first.msg);
      flextable.Support.delay(1000).then(function() {
        viewer.baseViewer.showErrors();
      });
    }
    var $jscomp$destructuring$var37 = fileObject.meta;
    var decodeEncoding = $jscomp$destructuring$var37.decodeEncoding;
    viewer.baseViewer.textView.encodingButton.setText(decodeEncoding);
  } catch (e) {
    viewer = this.errorPanel('VIEWER CMP ERROR');
  }
  return viewer;
}, errorPanel:function(message) {
  message = message === void 0 ? '' : message;
  return Ext.create({xtype:'container', hasErrors:true, html:message});
}});
Ext.define('flextable.components.fileViewer.FileViewer', {extend:'Ext.panel.Panel', alias:'widget.ftFileViewer', mixins:['flextable.mixins.Component'], config:{mimeType:''}, closable:true, header:false, layout:'card', moduleId:undefined, idSuffix:undefined, fileObject:{}, showNotification:function(msg, level) {
  var $jscomp$this = this;
  level = level === void 0 ? 'i' : level;
  this.notificationField.update(msg);
  Ext.defer(function() {
    try {
      if (!$jscomp$this.destroyed && $jscomp$this.notificationField && !$jscomp$this.notificationField.destroyed) {
        $jscomp$this.notificationField.update('');
      }
    } catch (e) {
    }
  }, 2000);
}, fetchAsArrayBuffer:function(url) {
  var headers = BpcCommon.Api.getCsrfToken();
  return fetch(url, {headers:headers}).then(function(r) {
    return r.arrayBuffer();
  });
}, arrayBufferToBase64:function(arrayBuffer) {
  return documents.Utils.arrayBufferToBase64(arrayBuffer);
}, getDelegatedComponentCfg:function(mime, base64str) {
  var obj = documents.Utils.getMinimalDocObject(mime, base64str);
  obj.record = Ext.create('Ext.data.Model', {base64string:base64str});
  return documents.Support.getViewerComponentByDocument(obj);
}, getTitlePrefix:function(childid) {
  return childid ? this.TR('DOCUMENT_FROM_STEP') + ': ' + childid : this.TR('DOCUMENT_PREVIEW');
}, initComponent:function() {
  var $jscomp$this = this;
  var $jscomp$destructuring$var38 = this.fileObject || {};
  var meta = $jscomp$destructuring$var38.meta;
  var $jscomp$destructuring$var39 = meta || {};
  var mime = $jscomp$destructuring$var39.mime;
  var childid = $jscomp$destructuring$var39.childid;
  var virtualId = $jscomp$destructuring$var39.virtualId;
  this.mimeType = mime;
  this.iconCls = this.iconForMime(mime);
  this.itemId = this.idSuffix + (childid || Ext.id());
  var titleId = virtualId || childid;
  this.title = this.getTitlePrefix(titleId);
  this.notificationField = Ext.create({xtype:'container'});
  if (this.fileObject.meta) {
    this.metaView = this.createMetaViewer();
  }
  this.metaField = Ext.create(Ext.applyIf({margin:'0 0 0 0'}, Ext.apply(this.baseButtonCfg('info-circle', 'META', 'FILE_BTN_META_TOOLTIP', false), {handler:function(b) {
    $jscomp$this.setActiveCard($jscomp$this.metaView);
  }})));
  var isHtml = mime === 'text/html';
  var isPdf = mime === 'application/pdf';
  var isMail = mime === 'message/rfc822' && flextable.Module.documentsAvailable;
  var isInternalDtoMail = mime === 'text/x-bpc-mpm+xml' && flextable.Module.documentsAvailable;
  var isZip = mime === 'application/zip' && flextable.Module.documentsAvailable;
  var zipButton = Ext.create({xtype:'button', text:this.TR('Archive'), iconCls:this.faIcon('fa-file-archive'), margin:'0 2 0 0', ui:'primary', hidden:!isZip, loadedSuccess:false, pdfCard:undefined, handler:function(btn) {
    if (!btn.loadedSuccess) {
      var mainArrayBuffer = undefined;
      $jscomp$this.fetchAsArrayBuffer($jscomp$this.fileObject.fileUrl).then(function(arrayBuffer) {
        mainArrayBuffer = arrayBuffer;
        return $jscomp$this.arrayBufferToBase64(arrayBuffer);
      }).then(function(base64str) {
        return $jscomp$this.getDelegatedComponentCfg($jscomp$this.fileObject.meta.mime, base64str);
      }).then(function(cmpCfg) {
        cmpCfg.documentsContext = null;
        cmpCfg.mainArrayBuffer = mainArrayBuffer;
        var p = Ext.create(cmpCfg);
        $jscomp$this.setActiveCard(p);
        btn.loadedSuccess = true;
        btn.pdfCard = p;
      });
    } else {
      $jscomp$this.setActiveCard(btn.pdfCard);
    }
  }});
  var mailButton = Ext.create({xtype:'button', text:this.TR('Mail'), iconCls:this.faIcon('fa-envelope'), margin:'0 2 0 0', ui:'primary', hidden:!isMail && !isInternalDtoMail, isInternalDtoMail:isInternalDtoMail, loadedSuccess:false, pdfCard:undefined, handler:function(btn) {
    if (!btn.loadedSuccess) {
      var mainArrayBuffer = undefined, dataUrl = undefined;
      if (btn.isInternalDtoMail) {
        try {
          var sourceString = $jscomp$this.fileObject.fileSource || '';
          var doc = flextable.util.Data.parseXml(sourceString, 'application/xml');
          var errorNode = doc.querySelector('parsererror');
          if (errorNode) {
            dataUrl = undefined;
          } else {
            var base64str = doc.querySelector('MIME').innerHTML;
            dataUrl = 'data:application/octet-binary;base64,' + base64str;
          }
        } catch (e) {
          dataUrl = undefined;
        }
      }
      var url = btn.isInternalDtoMail ? dataUrl : $jscomp$this.fileObject.fileUrl;
      var mime$6 = btn.isInternalDtoMail ? 'message/rfc822' : $jscomp$this.fileObject.meta.mime;
      $jscomp$this.fetchAsArrayBuffer(url).then(function(arrayBuffer) {
        mainArrayBuffer = arrayBuffer;
        return $jscomp$this.arrayBufferToBase64(arrayBuffer);
      }).then(function(base64str) {
        return $jscomp$this.getDelegatedComponentCfg(mime$6, base64str);
      }).then(function(cmpCfg) {
        cmpCfg.documentsContext = null;
        cmpCfg.mainArrayBuffer = mainArrayBuffer;
        var p = Ext.create(cmpCfg);
        $jscomp$this.setActiveCard(p);
        btn.loadedSuccess = true;
        btn.pdfCard = p;
      });
    } else {
      $jscomp$this.setActiveCard(btn.pdfCard);
    }
  }});
  var htmlButton = Ext.create({xtype:'button', text:this.TR('HTML'), iconCls:this.faIcon('fa-browser'), margin:'0 2 0 0', ui:'primary', hidden:!isHtml, loadedSuccess:false, pdfCard:undefined, handler:function(btn) {
    if (!btn.loadedSuccess) {
      var html = $jscomp$this.fileObject.file;
      var url = 'data:text/html,' + encodeURIComponent(html);
      var p = Ext.create({xtype:'panel', layout:'fit', items:[{xtype:'flextableDynamicHtmlContent', url:url}], getValue:function() {
        return html;
      }});
      $jscomp$this.setActiveCard(p);
      btn.loadedSuccess = true;
      btn.pdfCard = p;
    } else {
      $jscomp$this.setActiveCard(btn.pdfCard);
    }
  }});
  var pdfButton = Ext.create({xtype:'button', text:this.TR('PDF'), iconCls:this.faIcon('fa-file-pdf'), margin:'0 2 0 0', ui:'primary', hidden:!isPdf, loadedSuccess:false, pdfCard:undefined, handler:function(btn) {
    if (!btn.loadedSuccess) {
      var p = Ext.create({xtype:'panel', layout:'fit', items:[{xtype:'container', html:$jscomp$this.TR('LOADING')}]});
      $jscomp$this.copyButton.setDisabled(true);
      var headers = BpcCommon.Api.getCsrfToken();
      fetch($jscomp$this.fileObject.fileUrl, {headers:headers}).then(function(r) {
        return r.arrayBuffer();
      }).then(function(buffer) {
        var b = new Blob([buffer], {type:'application/pdf'});
        var url = URL.createObjectURL(b);
        var pdfContainer = Ext.create({xtype:'flextableDynamicHtmlContent', url:url});
        p.removeAll();
        p.add(pdfContainer);
        btn.loadedSuccess = true;
        btn.pdfCard = p;
      })["catch"](function() {
        p.removeAll();
        p.add({xtype:'container', html:flextable.Support.TR('ERROR')});
      });
      $jscomp$this.setActiveCard(p);
    } else {
      $jscomp$this.setActiveCard(btn.pdfCard);
    }
  }});
  var originalButton = Ext.create(Ext.apply({}, this.baseButtonCfg('fa-file', 'ORIGINAL', 'FILE_BTN_ORIGINAL_TOOLTIP', true), {handler:function() {
    $jscomp$this.setActiveCard($jscomp$this.baseViewer.displayText());
    flextable.Support.delay().then(function() {
      $jscomp$this.baseViewer.showErrors();
    });
  }}));
  var formatButton = Ext.create(Ext.apply({}, this.baseButtonCfg('fa-align-justify', 'FORMAT', 'FILE_BTN_FORMAT_TOOLTIP', true), {handler:function() {
    $jscomp$this.setActiveCard($jscomp$this.baseViewer.displayText('formatted'));
    flextable.Support.delay().then(function() {
      $jscomp$this.baseViewer.showErrors();
    });
  }}));
  var treeButton = Ext.create(Ext.apply({}, this.baseButtonCfg('fa-folder-tree', 'TREEVIEW', 'FILE_BTN_TREEVIEW_TOOLTIP', true), {hidden:!this.fileObject.meta.isXml, cardToShow:this.fileObject.treeView, handler:function(b) {
    $jscomp$this.setActiveCard(b.cardToShow);
  }}));
  this.copyButton = Ext.create(Ext.apply({}, this.baseButtonCfg('fa-copy', 'COPY', 'FILE_BTN_COPY_TOOLTIP', false), {handler:function(b) {
    var card = $jscomp$this.getLayout().getActiveItem();
    if (card.getValue) {
      if (flextable.Support.copyToClipBoard(card.getValue(), card)) {
        $jscomp$this.showNotification(flextable.Support.TR('COPIED_SUCCESS'));
      }
    }
  }}));
  this.downloadButton = Ext.create(Ext.apply({}, this.baseButtonCfg('fa-download', 'DOWNLOAD', 'FILE_BTN_DOWNLOAD_TOOLTIP', false), {disabled:!Ext.isDefined(this.moduleId) || this.moduleId === null, handler:function() {
    flextable.file.openFile($jscomp$this.fileObject.record, $jscomp$this.moduleId);
  }}));
  if (isHtml || isPdf || isMail || isZip) {
    var buttonsToHide = [formatButton, treeButton];
    if (isPdf || isZip) {
      buttonsToHide.push(originalButton);
    }
    buttonsToHide.map(function(b) {
      return b.setVisible(false);
    });
  }
  this.toolbarTop = Ext.create({xtype:'toolbar', dock:'top', padding:'3 0 3 0', items:[zipButton, htmlButton, pdfButton, mailButton, originalButton, formatButton, treeButton, {xtype:'tbfill'}, this.notificationField, {xtype:'tbfill'}, this.copyButton, this.downloadButton, this.metaField]});
  this.dockedItems = [this.toolbarTop];
  this.baseViewer = this.createBaseViewer();
  this.items = [this.baseViewer];
  this.listeners = {afterrender:function() {
    if (isHtml) {
      htmlButton.handler(htmlButton);
    }
    if (isPdf) {
      pdfButton.handler(pdfButton);
    }
    if (isMail) {
      mailButton.handler(mailButton);
    }
    if (isZip) {
      zipButton.handler(zipButton);
    }
  }};
  var tooltip = '\x3ctable\x3e';
  Object.keys(meta).map(function(k) {
    var o = {key:k, value:meta[k] || ''};
    var $jscomp$destructuring$var40 = o;
    var key = $jscomp$destructuring$var40.key;
    var value = $jscomp$destructuring$var40.value;
    tooltip += '\x3ctr\x3e\x3ctd\x3e' + key + '\x3c/td\x3e' + '\x3ctd\x3e' + value + '\x3c/td\x3e\x3c/tr\x3e';
  });
  tooltip += '\x3c/table\x3e';
  this.addTooltipConfig(this.getTooltipConfig(tooltip));
  this.callParent(arguments);
  if (this.fileObject.remote) {
    this.toolbarTop.hide();
    var loadingPanel = Ext.create({xtype:'panel', layout:'center', items:[{xtype:'panel', header:false, html:'FILE DESCRIPTION', bbar:[{text:flextable.Support.TR('LOAD_AND_SHOW'), ui:'primary', handler:function() {
      $jscomp$this.loadRemoteFile();
    }}]}]});
    this.getLayout().setActiveItem(loadingPanel);
  }
}, baseButtonCfg:function(iconCls, btnTextKey, btnTooltip, primary) {
  primary = primary === void 0 ? true : primary;
  return {xtype:'button', ui:primary === true ? 'primary' : 'secondary', iconCls:this.faIcon(iconCls), text:this.TR(btnTextKey), tooltip:this.TR(btnTooltip), margin:'0 2 0 0'};
}, remoteFileLoaded:false, loadRemoteFile:function() {
  var $jscomp$this = this;
  if (!this.remoteFileLoaded) {
    if (this.debugEnabled) {
      fetch('bpc-fe-flextable/resources/examples/single.json').then(function(r) {
        return r.json();
      }).then(function(json) {
        $jscomp$this.remoteFileLoaded = true;
        $jscomp$this.setRemoteFile(json.data[0]);
      });
      return;
    }
    this.fetchRemoteFileData(this.fileObject.remoteFileRequestData.url, this.fileObject.remoteFileRequestData.params).then(function(json) {
      var $jscomp$destructuring$var41 = json;
      var data = $jscomp$destructuring$var41.data;
      data = data || [];
      if (data.length) {
        $jscomp$this.remoteFileLoaded = true;
        $jscomp$this.setRemoteFile(data[0]);
        return;
      }
    }, function(error) {
    });
  }
}, setRemoteFile:function(item) {
  var p = this.fileObject.remoteContentSourceComponent.getViewerForItem(item);
  this.getLayout().setActiveItem(p);
}, fetchRemoteFileData:function(url, params) {
  return Ext.Ajax.request({url:url, params:params, method:'POST'}).then(function(response) {
    return Ext.decode(response.responseText, true);
  }, function(response) {
    return response;
  });
}, setActiveCard:function(card) {
  this.getLayout().setActiveItem(card);
}, createBaseViewer:function() {
  var meta = this.fileObject.meta || {};
  var textView = Ext.create({xtype:'ftText', value:this.fileObject.file ? this.fileObject.file : this.fileObject.fileSource || '-1', mime:meta.mime, readOnly:true});
  return Ext.create({xtype:'container', itemId:'flexFileView', layout:'fit', fileData:this.fileObject, items:[textView], textView:textView, getValue:function() {
    return textView.getValue();
  }, showErrors:function() {
    try {
      if (this.fileData.meta.isXml && this.fileData.hasErrors) {
        var $jscomp$destructuring$var42 = $jscomp.makeIterator(this.fileData.errors);
        var first = $jscomp$destructuring$var42.next().value;
        if (first && first.type === 'encoding_xml_file') {
          var lines = textView.editor.session.doc.getAllLines();
          var linesFound = [];
          for (var i = 0, l = lines.length; i < l; i++) {
            var line = lines[i];
            line = (line || '').toLowerCase();
            var match = line.indexOf('encoding\x3d') !== -1;
            if (match) {
              linesFound.push(i);
            }
          }
          var errors = linesFound.map(function(linesIndex) {
            return {row:linesIndex, column:0, text:first.msg, type:'error'};
          });
          textView.editor.getSession().setAnnotations(errors);
        }
      }
    } catch (e) {
      console.error('error displaying errors', e);
    }
  }, displayText:function(mode) {
    mode = mode === void 0 ? 'original' : mode;
    var isJson = this.fileData.meta.mime === 'application/json';
    if (isJson) {
      textView.setAceMode('json');
    }
    if (mode === 'original') {
      textView.setValue(this.fileData.fileSource || '-1');
    } else if (mode === 'formatted') {
      var fileValue = this.fileData.file || '-1';
      try {
        if (isJson) {
          fileValue = JSON.stringify(JSON.parse(fileValue), undefined, 4);
        }
      } catch (e) {
        fileValue = 'ERROR';
      }
      textView.setValue(fileValue);
    }
    return this;
  }});
}, createMetaViewer:function() {
  this.metaView = Ext.create({xtype:'ftFileMeta', fileObject:this.fileObject, viewer:this});
  return this.metaView;
}});
Ext.define('flextable.components.fileViewer.Meta', {extend:'Ext.panel.Panel', alias:'widget.ftFileMeta', mixins:['flextable.mixins.Component'], moduleId:undefined, fileObject:{}, header:false, flex:1, layout:'fit', hidden:true, scrollable:true, initComponent:function() {
  var $jscomp$this = this;
  var metaObject = this.fileObject.meta || {};
  var $jscomp$destructuring$var43 = metaObject;
  var directory = $jscomp$destructuring$var43.directory;
  directory = directory || '';
  var filename = this.getFileNameFromDirectory(directory);
  if (filename) {
    this.updateNotificationField(flextable.Support.TR('FILE') + ': ' + filename);
    metaObject.filename = filename;
  }
  var storeData = Object.keys(metaObject).map(function(k) {
    return {key:k.toUpperCase(), value:metaObject[k] || ''};
  });
  this.items = [{xtype:'grid', store:Ext.create('Ext.data.Store', {data:storeData}), listeners:{rowdblclick:function(tv, rec) {
    $jscomp$this.copyWithNotification(rec.get('value') || '', tv);
  }}, columns:[{dataIndex:'key', renderer:function(v) {
    v = v || '';
    return v.length ? '\x3cb\x3e' + v + '\x3c/b\x3e' : v;
  }}, {dataIndex:'value', flex:1}, {xtype:'actioncolumn', width:40, items:[{iconCls:this.faIcon('fa-clone'), tooltip:this.TR('COPY'), handler:function(tv, row, c, i, e, r) {
    $jscomp$this.copyWithNotification(r.get('value') || '', tv);
  }}]}]}];
  this.callParent(arguments);
}, updateNotificationField:function(str) {
  this.viewer.notificationField.update(str);
}, getFileNameFromDirectory:function(dir) {
  dir = dir === void 0 ? '' : dir;
  if (dir.indexOf(':') !== -1) {
    var parts = dir.split(':');
    if (parts.length > 1) {
      var filePart = parts[1] || '';
      if (filePart.indexOf('/') !== -1) {
        var folders = filePart.split('/');
        if (folders.length > 1) {
          var file = folders[1] || '';
          if (file.length) {
            return file;
          }
        }
      }
    }
  }
}});
Ext.define('flextable.components.fileViewer.Text', {extend:'Ext.panel.Panel', alias:'widget.ftText', mixins:['flextable.mixins.Component'], layout:'fit', editor:undefined, value:undefined, mime:undefined, readOnly:false, initComponent:function() {
  this.editorId = Ext.id();
  this.items = [this.fullWidthContainer(this.editorId)];
  this.listeners = {afterrender:this.initEditor.bind(this), beforedestroy:this.destroyEditor.bind(this), resize:this.onResize.bind(this)};
  this.lineButton = Ext.create({xtype:'button', iconCls:this.faIcon('fa-grip-lines'), overCls:'', focusCls:'', tooltip:this.TR('LINES_COUNT'), text:'0'});
  this.encodingButton = Ext.create({xtype:'button', iconCls:this.faIcon('fa-file-code'), overCls:'', focusCls:'', tooltip:this.TR('FILE_STREAM_ENCODING')});
  this.warningButton = Ext.create({xtype:'button', iconCls:this.faIcon('exclamation-triangle flextable-error'), overCls:'flextable-cursor-pointer', focusCls:'', hidden:true, handleMouseEvents:false, text:'0'});
  this.addEditToolbar();
  this.bbar = [this.lineButton, {xtype:'tbfill'}, this.encodingButton];
  this.callParent(arguments);
}, setWarning:function(text, visible) {
  text = text === void 0 ? '' : text;
  visible = visible === void 0 ? true : visible;
  this.warningButton.setVisible(visible);
  this.warningButton.setText(text);
}, addEditToolbar:function() {
  var $jscomp$this = this;
  this.pageUp = Ext.create({xtype:'button', ui:'secondary', iconCls:this.faIcon('fa-arrow-up'), tooltip:this.TR('EDITOR_PAGE_UP'), handler:function() {
    $jscomp$this.editor.gotoPageUp();
  }});
  this.pageDown = Ext.create({xtype:'button', ui:'secondary', iconCls:this.faIcon('fa-arrow-down'), tooltip:this.TR('EDITOR_PAGE_DOWN'), handler:function() {
    $jscomp$this.editor.gotoPageDown();
  }});
  this.copyAll = Ext.create({xtype:'button', ui:'secondary', iconCls:this.faIcon('fa-clipboard'), tooltip:this.TR('EDITOR_COPY_ALL'), handler:function() {
  }});
  this.copySelection = Ext.create({xtype:'button', ui:'secondary', iconCls:this.faIcon('fa-copy'), tooltip:this.TR('EDITOR_COPY_SELECTION'), handler:function() {
  }});
  this.fontIncrease = Ext.create({xtype:'button', ui:'secondary', iconCls:this.faIcon('fa-plus'), tooltip:this.TR('EDITOR_COPY_SELECTION'), handler:function() {
    var fontSize = $jscomp$this.editor.getFontSize();
    fontSize++;
    $jscomp$this.editor.setFontSize(fontSize);
  }});
  this.fontDecrease = Ext.create({xtype:'button', ui:'secondary', iconCls:this.faIcon('fa-minus'), tooltip:this.TR('EDITOR_COPY_SELECTION'), handler:function() {
    var fontSize = $jscomp$this.editor.getFontSize();
    fontSize--;
    $jscomp$this.editor.setFontSize(fontSize);
  }});
  this.tbar = [this.pageUp, this.pageDown, this.copyAll, this.copySelection, this.fontIncrease, this.fontDecrease, {xtype:'tbspacer', width:32}, this.warningButton];
}, initEditor:function() {
  this.editor = ace.edit(this.editorId);
  this.editor.setTheme('ace/theme/chrome');
  this.setMime(this.mime || 'xml');
  this.editor.setOptions({enableBasicAutocompletion:true, enableLiveAutocompletion:true, showLineNumbers:true, showPrintMargin:false});
  if (this.readOnly) {
    this.editor.setReadOnly(true);
  }
  if (this.value) {
    this.setValue(this.value);
  }
}, setMime:function(mime) {
  mime = mime === void 0 ? '' : mime;
  var map = {'application/json':'json', 'application/javascript':'javascript', 'application/ecmascript':'javascript', 'application/edifact':'edifact', 'text/css':'css', 'text/html':'html', 'text/xml':'xml'};
  var editorLanguage = map[mime] || (mime.indexOf('xml') !== -1 ? 'xml' : undefined);
  if (editorLanguage) {
    this.setAceMode(editorLanguage);
  }
}, setAceMode:function(editorLanguage) {
  this.editor.getSession().setMode('ace/mode/' + editorLanguage);
}, onResize:function() {
  if (this.editor) {
    this.editor.resize();
  }
}, getValue:function() {
  if (this.editor) {
    return this.editor.getValue();
  }
}, setValue:function(value) {
  if (this.editor) {
    this.editor.setValue(value, -1);
    this.updateLineCount();
  }
}, updateLineCount:function() {
  this.lineButton.setText(this.getLineCount());
}, getLineCount:function() {
  var doc = this.editor.getSession().getDocument();
  return (doc ? doc.getAllLines() || [] : []).length;
}, destroyEditor:function() {
  if (this.editor) {
    this.editor.destroy.bind(this.editor);
  }
}, fullWidthContainer:function(id) {
  return Ext.create({xtype:'container', html:'\x3cdiv style\x3d"height: 100%;width: 100%"\x3e\x3cdiv style\x3d"height: 100%;width: 100%" id\x3d"' + id + '"\x3e\x3c/div\x3e\x3c/div\x3e'});
}});
Ext.define('flextable.components.fileViewer.Tree', {extend:'Ext.tree.Panel', alias:'widget.ftTree', viewConfig:{enableTextSelection:true}, mixins:['flextable.mixins.Component'], rootVisible:false, scrollable:true, fileSource:undefined, clipboardProperty:'copyClipboardValue', initComponent:function() {
  var $jscomp$this = this;
  this.pathButton = Ext.create({xtype:'button', iconCls:this.faIcon('fa-code-branch')});
  this.columns = [{xtype:'treecolumn', text:this.TR('TREE'), dataIndex:'text', flex:3}, {text:this.TR('ELEMENTS'), dataIndex:'childElementCount', width:90, renderer:function(val, meta, rec) {
    return val === 0 ? '' : val;
  }}, {text:this.TR('ATTRIBUTES'), dataIndex:'attributes', flex:2, renderer:function(val, meta, rec) {
    return (val || []).map(function(attribute) {
      var $jscomp$destructuring$var44 = attribute;
      var key = $jscomp$destructuring$var44.key;
      var value = $jscomp$destructuring$var44.value;
      return key + ' \x3d ' + value;
    }).join('\x3cbr\x3e');
  }}];
  this.store = this.createXmlTreeStore();
  this.bbar = [this.pathButton];
  this.listeners = {select:function(treeModel, node) {
    $jscomp$this.updatePathButton($jscomp$this.getPathForNode(node));
  }, rowdblclick:function(tv, rec) {
    var textValue = rec.get($jscomp$this.clipboardProperty) || '';
    if (textValue.length > 0 && flextable.Support.copyToClipBoard(textValue, tv)) {
      BpcCommon.Api.showNotification(textValue + ' ' + flextable.Support.TR('COPIED_SUCCESS'));
    }
  }};
  this.callParent(arguments);
}, createXmlTreeStore:function() {
  var storeData = {};
  try {
    var xmlData = flextable.util.Data.parseXml(this.fileSource);
    if (xmlData !== null) {
      storeData = this.nodeToJsonTree(xmlData);
    }
    this.fileSource = null;
  } catch (e) {
    storeData = {};
  }
  return Ext.create('Ext.data.TreeStore', {root:{expanded:true, children:storeData}});
}, getPathForNode:function(node) {
  var $jscomp$this = this;
  var recordIds = (node.getPath() || '').split('/');
  return recordIds.map(function(name) {
    if (name === 'root') {
      return name;
    } else {
      var r = $jscomp$this.store.getById(name);
      if (r) {
        return r.get('text');
      }
      return name;
    }
  });
}, updatePathButton:function(path) {
  path = path === void 0 ? [] : path;
  this.pathButton.setText(path.join('/'));
}, getNodeInfo:function(node) {
  var type = node.nodeType;
  var childElementCount = node.childElementCount;
  var name = type === 10 ? node.name : node.tagName;
  var nodeName = node.nodeName;
  var attributes = [];
  if (node.attributes) {
    attributes = Array.from(node.attributes);
    attributes = attributes.map(function(attributeNode) {
      return {key:attributeNode.nodeName, value:attributeNode.value};
    });
  }
  childElementCount = childElementCount || 0;
  var leaf = childElementCount === 0;
  var copyClipboardValue = '';
  if (childElementCount === 0 && node.textContent) {
    var text = node.textContent;
    text = text || '';
    if (text.length) {
      name += ' \x3d ' + text;
      copyClipboardValue = text;
    }
  }
  if (type === 10) {
    var publicId = node.publicId;
    var systemId = node.systemId;
    attributes.push({key:'publicId', value:publicId});
    attributes.push({key:'systemId', value:systemId});
  }
  return {type:type, childElementCount:childElementCount, text:name, attributes:attributes, nodeName:nodeName, leaf:leaf, copyClipboardValue:copyClipboardValue};
}, handleChildNodes:function(nodes) {
  var $jscomp$this = this;
  nodes = nodes === void 0 ? [] : nodes;
  var nodesArray = Array.from(nodes);
  return (nodesArray || []).map(function(node) {
    var item = $jscomp$this.getNodeInfo(node);
    var count = item.childElementCount || 0;
    if (count > 0 && typeof node.childNodes === 'object') {
      item.children = $jscomp$this.handleChildNodes(node.childNodes);
    }
    return item;
  });
}, nodeToJsonTree:function(node) {
  var attributes = ['characterSet', 'xmlVersion', 'xmlEncoding'].map(function(name) {
    var value = node && node[name] ? node[name] : '-1';
    return {key:name, value:value};
  });
  return {text:node.nodeName, draggable:false, attributes:attributes, children:node.childElementCount && node.childNodes ? this.handleChildNodes(node.childNodes) : []};
}});
Ext.define('flextable.components.processViewer.ProcessViewer', {extend:'Ext.panel.Panel', alias:'widget.flextableProcessViewer', mixins:['flextable.mixins.Component'], layout:{type:'hbox', align:'stretch'}, dataType:'record', record:undefined, moduleInstance:undefined, externalData:undefined, fieldTitle:undefined, initComponent:function() {
  this.defaults = {record:this.record, dataType:this.dataType, moduleInstance:this.moduleInstance, externalData:this.externalData};
  this.fieldSet = this.createFieldset();
  this.items = [this.fieldSet];
  this.flex = 1;
  this.callParent(arguments);
  this.createItemView();
}, createFieldset:function() {
  return Ext.create({xtype:'fieldset', flex:1, title:this.fieldTitle || flextable.Support.TR('DETAILS'), layout:{type:'vbox', align:'stretch'}});
}, createItemView:function() {
  var $jscomp$this = this;
  var obj = this.dataType === 'record' ? this.record.getData() : this.externalData || {};
  Object.keys(obj).filter(function(k) {
    return $jscomp$this.dataType === 'record' ? k !== 'R__' && k !== 'id' : true;
  }).map(function(key) {
    $jscomp$this.fieldSet.add({xtype:'box', html:$jscomp$this.getFlexItem(key, obj[key])});
  });
}, getFlexItem:function(rawKey, rawValue) {
  rawKey = rawKey || '';
  rawValue = rawValue || '';
  if (this.dataType === 'record' && this.moduleInstance) {
    var $jscomp$destructuring$var45 = $jscomp.makeIterator(this.moduleInstance.getColumn(rawKey));
    var firstColumn = $jscomp$destructuring$var45.next().value;
    if (firstColumn && firstColumn.renderer) {
      var $jscomp$destructuring$var46 = firstColumn;
      var renderer = $jscomp$destructuring$var46.renderer;
      var text = $jscomp$destructuring$var46.text;
      var dataIndex = $jscomp$destructuring$var46.dataIndex;
      var menuText = $jscomp$destructuring$var46.menuText;
      var header = $jscomp$destructuring$var46.header;
      var renderedValue = renderer(rawValue);
      var isJson = typeof rawValue === 'object';
      rawValue = (renderedValue || '').length && (renderedValue || '') != rawValue ? renderer(rawValue) + ' (' + (isJson ? JSON.stringify(rawValue) : rawValue) + ' ) ' : rawValue;
      rawKey = (text || '').trim().length ? text : header || menuText || dataIndex || rawKey;
    }
  }
  return '\x3cdiv style\x3d"display: flex; flex-direction: row"\x3e\x3cdiv style\x3d"flex-grow: 1;max-width: 15%"\x3e' + rawKey + ': \x3c/div\x3e\x3cdiv style\x3d"flex-grow: 3"\x3e' + rawValue + '\x3c/div\x3e\x3c/div\x3e';
}});
Ext.define('flextable.moduleConfigurationComponents.Main', {extend:'BpcCommon.component.panel.moduleConfigurationComponents.Wrapper', alias:'widget.flextableConfigMain', mixins:['flextable.mixins.Component'], initComponent:function() {
  this.callParent(arguments);
  this.setIconCls(this.faIcon('fa-database'));
  this.setTitle(this.TR('FLEXTABLE_ADMIN'));
  this.saveButton.setVisible(false);
  this.resetButton.setVisible(false);
}, onSelect:function(grid, record) {
  this.settingsWrapper.removeAll();
  var moduleId = record.get('moduleId');
  if (flextable.Support.isDatabaseInstance(moduleId)) {
    this.settingsWrapper.add({xtype:'flextableTable', moduleId:moduleId, header:false});
  } else {
    this.settingsWrapper.add(this.messagePanel('NOT_SUPPORTED', 'NOT_SUPPORTED_FOR_HTTP_DATA'));
  }
}, getRendererConfig:function(moduleId) {
  var $jscomp$destructuring$var47 = BpcCommon.Api.getSetting(moduleId, flextable.Support.keys.cfg) || {};
  var renderer = $jscomp$destructuring$var47.renderer;
  return renderer || {};
}});
Ext.define('flextable.moduleConfigurationComponents.Network', {extend:'BpcCommon.component.panel.moduleConfigurationComponents.Wrapper', alias:'widget.flextableConfigNetwork', mixins:['flextable.mixins.Component'], initComponent:function() {
  this.callParent(arguments);
  this.componentsGrid.hide();
  this.setIconCls(this.faIcon('fa-network-wired'));
  this.setTitle(this.TR('FLEXTABLE_NETWORK_ADMIN'));
  this.saveButton.setVisible(false);
  this.resetButton.setVisible(false);
  this.settingsWrapper.removeAll();
  this.showNicData();
}, showNicData:function() {
  var $jscomp$this = this;
  flextable.Api.getNetworkInfo().then(function(json) {
    var items = (json || []).map(function(inf) {
      var title = $jscomp$this.TR('INTERFACE') + ': ' + ((inf || {}).displayName || 'No Name') + ' - MAC: ' + ((inf || {}).macAddress || '-1');
      return {xtype:'panel', title:title, layout:'fit', iconCls:$jscomp$this.faIcon('fa-ethernet'), items:[{xtype:'textarea', grow:true, value:JSON.stringify(inf, undefined, 4)}]};
    });
    $jscomp$this.settingsWrapper.add({xtype:'tabpanel', items:items});
  });
}, onSelect:function(grid, record) {
}});
Ext.define('flextable.manager.Renderer', {extend:'Ext.panel.Panel', alias:'widget.flextableRenderer', title:'Renderer', mixins:['flextable.mixins.Component'], viewConfig:{enableTextSelection:true}, layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  var $jscomp$this = this;
  var conf = BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.cfg) || {};
  var $jscomp$destructuring$var48 = conf;
  var renderer = $jscomp$destructuring$var48.renderer;
  var main = $jscomp$destructuring$var48.main;
  var details = $jscomp$destructuring$var48.details;
  renderer = renderer || {};
  main = main || {};
  details = details || {};
  var rendererNames = Object.keys(renderer || {});
  this.rendererStoreData = rendererNames.map(function(name) {
    var map = renderer[name].valueMap || {};
    return {id:name, data:Object.keys(map).map(function(value) {
      var item = map[value] || {};
      item.value = value;
      return item;
    })};
  });
  this.rendererGrid = Ext.create({title:'\x3e ' + (rendererNames.length ? rendererNames[0] : this.TR('NO_RENDERER_DEFINED')), xtype:'grid', flex:1, viewConfig:{emptyText:flextable.Support.TR('NO_DATA')}, store:Ext.create('Ext.data.Store', {data:rendererNames.length ? this.rendererStoreData.filter(function(item) {
    return item.id === rendererNames[0];
  })[0].data : []}), columns:['value', 'label', 'iconCls', 'color'].map(function(id) {
    var col = {dataIndex:id, text:id.toUpperCase(), flex:id === 'label' || id === 'value' ? 2 : 1};
    if (id === 'iconCls') {
      col.renderer = function(v, m, r) {
        return flextable.Support.getSpanForIconCls(v, r.get('color'));
      };
    }
    return col;
  }).concat([{xtype:'actioncolumn', width:60, items:[{iconCls:this.faIcon('fa-copy'), handler:function(tv, rowIndex, colIndex) {
    var data = tv.store.getAt(rowIndex).getData();
    tv.store.add({value:data.value || '', iconCls:data.iconCls || '', label:data.label || '', color:data.color || '#eee'});
  }}, {iconCls:this.faIcon('fa-times'), handler:function(tv, rowIndex, colIndex) {
    tv.store.removeAt(rowIndex);
  }}]}]), tbar:[{xtype:'checkbox', margin:'0 0 0 5', boxLabel:this.TR('ICON_ONLY')}, {xtype:'checkbox', margin:'0 0 0 5', boxLabel:this.TR('COMPARE_LOWER')}, {xtype:'tbfill'}, {text:this.TR('ADD_EMPTY')}, {text:this.TR('ADD_MATCH_ALL_FALLBACK')}], bbar:[{text:'Usages: '}, {xtype:'tbfill'}, {iconCls:this.faIcon('fa-save')}]});
  this.items = [this.rendererGrid];
  var getCount = function(cols, dataIndex) {
    cols = cols || [];
    return cols.filter(function(col) {
      return col.dataIndex === dataIndex;
    }).length;
  };
  var getTitle = function(dataIndex) {
    return '\x3e ' + dataIndex;
  };
  this.tbar = rendererNames.map(function(name) {
    return {text:name, rendererBtn:true, scope:$jscomp$this, handler:function(b) {
      this.rendererGrid.store.removeAll();
      this.rendererGrid.setTitle(getTitle(b.text));
      this.rendererGrid.store.add(this.rendererStoreData.filter(function(item) {
        return item.id === b.text;
      })[0].data || []);
    }};
  }).concat([{xtype:'tbfill'}, {text:this.TR('REMOVE_ALL'), handler:function(btn) {
    this.rendererGrid.setTitle(this.TR('NO_RENDERER'));
    this.rendererGrid.store.removeAll();
    this.rendererStoreData = [];
    this.query('button[rendererBtn]').map(function(b) {
      return b.destroy();
    });
  }.bind(this)}]);
  this.callParent(arguments);
}});
Ext.define('flextable.manager.Table', {extend:'Ext.panel.Panel', alias:'widget.flextableTable', mixins:['flextable.mixins.Component'], layout:{type:'vbox', align:'stretch'}, dbManageComponents:[], initComponent:function() {
  var $jscomp$this = this;
  this.title = this.TR('CONNECTION_INFO');
  this.iconCls = this.faIcon('fa-ethernet');
  this.connectionInfoPanelToolbar = Ext.create({margin:'5 5 5 5', xtype:'container', layout:{type:'hbox', align:'stretch'}});
  this.connectionInfoPanel = Ext.create({xtype:'fieldset', title:this.TR('CONNECTION_DETAILS'), layout:'fit', items:[this.connectionInfoPanelToolbar]});
  this.primaryStore = Ext.create('Ext.data.Store', {data:[]});
  this.columnStore = Ext.create('Ext.data.Store', {data:[]});
  this.tableTypesStore = Ext.create('Ext.data.Store', {data:[]});
  this.loadSchemaCatalogBtn = Ext.create({xtype:'button', iconCls:this.faIcon('fa-sync'), tooltip:'Schemas \x26 Catalogs', ui:'secondary', handler:function() {
    $jscomp$this.loadSchemasAndCatalogs();
  }});
  this.schemaFieldSet = Ext.create(this.getFieldsetColumn(this.TR('TABLES_SCHEMAS'), 'schemaName', [{dataIndex:'TABLE_SCHEM', flex:1}, {dataIndex:'TABLE_CATALOG', flex:1, hidden:true}], 'TABLE_SCHEM', [this.loadSchemaCatalogBtn]));
  this.defaultDatabaseTypes = BpcCommon.Api.getSetting(this.moduleId, 'defaultTableTypes') || ['VIEW', 'TABLE'];
  this.catalogsFieldSet = Ext.create(this.getFieldsetColumn(this.TR('TABLES_CATALOGS'), 'catalogName', [{dataIndex:'TABLE_CAT', flex:1}], 'TABLE_CAT'));
  this.schemaFieldSet.selectField.on('change', function(f, newVal) {
    return $jscomp$this.callLoadTableButton();
  });
  this.catalogsFieldSet.selectField.on('change', function(f, newVal) {
    return $jscomp$this.callLoadTableButton();
  });
  var tableFieldSet = this.getFieldsetColumn(this.TR('TABLES_VIEWS'), 'tableViewName', [{dataIndex:'TABLE_NAME', flex:1}, {dataIndex:'TABLE_TYPE'}, {xtype:'actioncolumn', hidden:!flextable.Support.isDbAdmin(), width:30, items:[{iconCls:this.faIcon('fa-trash'), tooltip:this.TR('DELETE'), handler:function(v, rI, cI, item, e, record) {
    $jscomp$this.doDropTable(record.get('TABLE_NAME'));
  }, isActionDisabled:function(view, rowIndex, colIndex, item, record) {
    return !flextable.Support.isDbAdmin();
  }}]}], 'TABLE_NAME', [{iconCls:this.faIcon('fa-plus'), ui:'secondary', disabled:true, handler:function() {
  }}, {iconCls:this.faIcon('fa-cog'), ui:'secondary', tooltip:'Change table types filter', handler:function() {
    flextable.Api.getTableTypes($jscomp$this.moduleId).then(function(data) {
      var $jscomp$destructuring$var49 = data;
      var tableTypes = $jscomp$destructuring$var49.tableTypes;
      tableTypes = tableTypes || [];
      tableTypes = tableTypes.map(function(typeObj) {
        var $jscomp$destructuring$var50 = typeObj;
        var TABLE_TYPE = $jscomp$destructuring$var50.TABLE_TYPE;
        typeObj.selected = $jscomp$this.defaultDatabaseTypes.indexOf(TABLE_TYPE) !== -1;
        return typeObj;
      });
      return tableTypes;
    }).then(function(tableTypes) {
      var typesStore = Ext.create('Ext.data.Store', {data:tableTypes});
      return Ext.create('Ext.window.Window', {title:'Types', height:document.body.clientHeight * 0.8, width:document.body.clientWidth * 0.5, layout:'fit', items:[{xtype:'grid', store:typesStore, columns:[{xtype:'checkcolumn', dataIndex:'selected', text:'Selected'}, {dataIndex:'TABLE_TYPE', flex:1, text:'Type'}]}], bbar:[{xtype:'tbfill'}, {ui:'secondary', iconCls:$jscomp$this.faIcon('fa-save'), text:$jscomp$this.TR('SAVE')}, {ui:'primary', iconCls:$jscomp$this.faIcon('fa-sync'), text:$jscomp$this.TR('APPLY'), 
      handler:function(b) {
        var newTypes = [];
        typesStore.each(function(r) {
          if (r.get('selected')) {
            newTypes.push(r.get('TABLE_TYPE'));
          }
        });
        $jscomp$this.defaultDatabaseTypes = newTypes;
        $jscomp$this.loadTablesAndViews();
        b.up('window').close();
      }}]});
    }).then(function(win) {
      win.show();
    });
  }}, {xtype:'button', iconCls:this.faIcon('fa-sync'), tooltip:'Tables \x26 Views', itemId:'tableViewsBtn', ui:'secondary', handler:function() {
    $jscomp$this.loadTablesAndViews($jscomp$this.defaultDatabaseTypes);
  }, disabled:true}]);
  tableFieldSet.selectField.on('change', function(f, tableName) {
    $jscomp$this.primaryStore.removeAll();
    $jscomp$this.columnStore.removeAll();
    if (tableName && tableName.length) {
      flextable.Api.getTableMeta($jscomp$this.moduleId, tableName).then(function(obj) {
        $jscomp$this.tableDetailsFieldSet.updateTableContent(tableName || '', obj);
      });
      return;
    }
    $jscomp$this.tableDetailsFieldSet.updateTableContent();
  });
  this.tableViewsFieldSet = Ext.create(tableFieldSet);
  this.deleteTableButton = Ext.create({xtype:'button', ui:'secondary', iconCls:this.faIcon('fa-trash'), disabled:true, handler:function(b) {
    var fs = b.up('fieldset');
    if (fs._tableName) {
      $jscomp$this.doDropTable(fs._tableName);
    }
  }});
  this.tableDetailsFieldSet = Ext.create({xtype:'fieldset', flex:2, title:this.TR('TABLE_DETAILS'), baseTitle:this.TR('TABLE_DETAILS'), _tableName:undefined, primaryStore:this.primaryStore, columnStore:this.columnStore, deleteTableButton:this.deleteTableButton, updateTitle:function(tableName) {
    var parts = [this.baseTitle];
    if (tableName) {
      parts.push(tableName);
      this._tableName = tableName;
    }
    this.setTitle(parts.join(' - '));
  }, updateTableContent:function(tableName, metaResponse) {
    tableName = tableName === void 0 ? '' : tableName;
    metaResponse = metaResponse === void 0 ? {} : metaResponse;
    tableName = tableName || '';
    tableName = tableName.length === 0 ? undefined : tableName;
    this.updateTitle(tableName);
    var $jscomp$destructuring$var51 = metaResponse || {};
    var tableColumnPrimaryKeys = $jscomp$destructuring$var51.tableColumnPrimaryKeys;
    var tableColumnDetails = $jscomp$destructuring$var51.tableColumnDetails;
    this.primaryStore.add(tableColumnPrimaryKeys || []);
    this.columnStore.add(tableColumnDetails || []);
    var canDelete = flextable.Support.isDbAdmin();
    this.deleteTableButton.setDisabled(canDelete ? !tableName : true);
  }, layout:'fit', items:[{xtype:'container', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'grid', viewConfig:{emptyText:this.TR('NO_DATA')}, minHeight:100, title:this.TR('PRIMARY_KEYS'), iconCls:this.faIcon('fa-star-of-life'), store:this.primaryStore, style:'border:0px!important;', columns:[{dataIndex:'COLUMN_NAME', flex:1}, {dataIndex:'PK_NAME', flex:1}]}, {xtype:'grid', flex:2, title:this.TR('COLUMN_INFO'), iconCls:this.faIcon('fa-columns'), store:this.columnStore, style:'border:0px!important;', 
  viewConfig:{emptyText:this.TR('NO_DATA')}, columns:[{dataIndex:'COLUMN_NAME', flex:1}, {dataIndex:'DATA_TYPE_NAME', flex:1}, {dataIndex:'DATA_TYPE'}, {dataIndex:'IS_AUTOINCREMENT', hidden:true}, {dataIndex:'IS_NULLABLE', hidden:true}, {dataIndex:'COLUMN_SIZE', hidden:true}].map(function(c) {
    c.renderer = function(v, m, r) {
      var data = r.getData();
      if (data.id) {
        delete data.id;
      }
      var tooltip = {};
      Object.keys(data).map(function(propName) {
        tooltip[flextable.Support.TR(propName)] = data[propName];
      });
      m.tdAttr = "data-qtip\x3d'" + flextable.Module.arrayToHtmlTable([tooltip]) + "'";
      return v;
    };
    return c;
  }), dockedItems:[{dock:'bottom', xtype:'toolbar', padding:'5 0 5 0', items:[this.deleteTableButton, {iconCls:this.faIcon('fa-ban')}, {xtype:'tbfill'}, {iconCls:this.faIcon('fa-clone')}, {iconCls:this.faIcon('fa-edit')}].map(function(o) {
    o.ui = 'secondary';
    if (!o.hasOwnProperty('disabled')) {
      o.disabled = true;
    }
    return o;
  })}]}]}]});
  this.dbManageComponents = [this.schemaFieldSet, this.catalogsFieldSet, this.tableViewsFieldSet, this.tableDetailsFieldSet];
  this.items = [this.connectionInfoPanel, {xtype:'panel', flex:2, layout:{type:'hbox', align:'stretch'}, items:this._padArray(this._split(), this.dbManageComponents)}];
  this.integrationRestricted = BpcCommon.Api.getSetting(this.moduleId, 'onlyAsPlugin');
  if (this.integrationRestricted) {
    this.items = [this.messagePanel('INTEGRATION_RESTRICTED', 'INTEGRATION_RESTRICTED_AS_PLUGIN_ONLY', {flex:1})];
  }
  this.callParent(arguments);
  if (!this.integrationRestricted) {
    this.loadDriverData();
  }
}, doDropTable:function(tableName) {
  var $jscomp$this = this;
  this.askAsync('DELETE_TABLE', 'TABLE_WILL_BE_DELETED_PLEASE_CONFIRM').then(function(yes) {
    if (yes) {
      var selTable = $jscomp$this.tableViewsFieldSet.selectField.getValue();
      return flextable.Api.admin.table.drop($jscomp$this.moduleId, tableName).then(function(success) {
        if (success) {
          if (selTable === tableName) {
            $jscomp$this.tableViewsFieldSet.selectField.reset();
          }
          $jscomp$this.callLoadTableButton();
          $jscomp$this.notification($jscomp$this.TR('TABLE_DELETED'));
          return;
        }
        $jscomp$this.notification($jscomp$this.TR('TABLE_DELETE_ERROR'));
      });
    }
  });
}, callLoadTableButton:function() {
  var b = this.down('#tableViewsBtn');
  if (b) {
    b.enable();
    b.handler(b);
  }
}, getFieldsetColumn:function(title, itemId, columns, selectRecordField, buttons) {
  columns = columns === void 0 ? [] : columns;
  buttons = buttons === void 0 ? [] : buttons;
  var selectField = Ext.create({xtype:'textfield', emptyText:title, itemId:itemId + 'Field', flex:1});
  var totalBtn = Ext.create({xtype:'button', iconCls:this.faIcon('fa-database'), text:'0'});
  var store = Ext.create('Ext.data.Store', {data:[], listeners:{datachanged:function(s) {
    totalBtn.setText('' + s.getCount());
  }}});
  var grid = Ext.create({xtype:'grid', style:'border:0px!important;', viewConfig:{emptyText:this.TR('NO_DATA')}, dockedItems:[{dock:'top', xtype:'container', layout:{type:'hbox', 'align':'stretch'}, padding:'5 0 5 0', items:[selectField]}, {dock:'bottom', xtype:'toolbar', padding:'5 0 5 0', items:[totalBtn, {xtype:'tbfill'}].concat(buttons)}], store:store, columns:columns, listeners:{select:function(selModel, r) {
    selectField.setValue(r.get(selectRecordField));
  }}});
  return {xtype:'fieldset', title:title, flex:1, layout:'fit', selectField:selectField, grid:grid, itemId:itemId, items:[grid]};
}, loadTablesAndViews:function(types) {
  var $jscomp$this = this;
  types = types === void 0 ? this.defaultDatabaseTypes : types;
  this.tableViewsFieldSet.grid.store.removeAll();
  flextable.Api.getTablesViews(this.moduleId, {mode:'tablesViews', types:types.join(','), schemaName:this.schemaFieldSet.selectField.getValue()}).then(function(data) {
    var storeData = [];
    Object.keys(data).map(function(key) {
      storeData = storeData.concat(data[key]);
    });
    $jscomp$this.tableViewsFieldSet.grid.store.add(storeData);
  });
}, loadAndSetSchemas:function() {
  var $jscomp$this = this;
  return flextable.Api.getSchemas(this.moduleId).then(function(data) {
    $jscomp$this.schemaFieldSet.grid.store.removeAll();
    $jscomp$this.schemaFieldSet.grid.store.add(data.schemas || []);
  });
}, loadAndSetCatalogs:function() {
  var $jscomp$this = this;
  return flextable.Api.getCatalogs(this.moduleId).then(function(data) {
    $jscomp$this.catalogsFieldSet.grid.store.removeAll();
    $jscomp$this.catalogsFieldSet.grid.store.add(data.catalogs || []);
  });
}, loadSchemasAndCatalogs:function() {
  var $jscomp$this = this;
  this.loadSchemaCatalogBtn.setDisabled(true);
  return Promise.all([this.loadAndSetSchemas(), this.loadAndSetCatalogs()]).then(function() {
    $jscomp$this.loadSchemaCatalogBtn.setDisabled(false);
    return true;
  });
}, loadDriverData:function() {
  var $jscomp$this = this;
  this.setLoading(flextable.Support.TR('FETCHING_DATA'));
  var product;
  flextable.Api.getDriverInfo(this.moduleId).then(function(connectionObject) {
    var driver = (connectionObject || {}).driver || {};
    Object.keys(driver).map(function(propName) {
      if (propName === 'databaseProductName') {
        product = driver[propName] || '-1';
      }
      var o = {xtype:'textfield', fieldLabel:flextable.Support.TR('DB_' + propName), value:driver[propName] || '-1', readOnly:true, margin:'0 5 0 5', flex:1};
      return $jscomp$this.connectionInfoPanelToolbar.add(o);
    });
  }).then(function() {
    try {
      $jscomp$this.loadSchemasAndCatalogs().then(function() {
        var lowerProduct = (product || '').toLowerCase();
        var connectionId = BpcCommon.Api.getSetting($jscomp$this.moduleId, 'backendConnection');
        if (lowerProduct === 'oracle') {
          var user = BpcCommon.Api.getSetting(connectionId, 'user');
          user = user || '';
          if (user.length) {
            var r = $jscomp$this.schemaFieldSet.grid.store.findRecord('TABLE_SCHEM', user);
            if (r) {
              $jscomp$this.schemaFieldSet.grid.setSelection([r]);
            }
          }
        }
        if (lowerProduct === 'mariadb') {
          var url = BpcCommon.Api.getSetting(connectionId, 'url');
          var $jscomp$destructuring$var52 = $jscomp.makeIterator((url || '').split('/').reverse());
          var catalog = $jscomp$destructuring$var52.next().value;
          if (catalog) {
            var r$7 = $jscomp$this.catalogsFieldSet.grid.store.findRecord('TABLE_CAT', catalog);
            if (r$7) {
              $jscomp$this.catalogsFieldSet.grid.setSelection([r$7]);
            }
          }
        }
      });
    } catch (e) {
    }
  })["catch"](function(e) {
    var errorJson = flextable.Support.getResponseObject(e);
    $jscomp$this.handleError(errorJson);
  })["finally"](function() {
    $jscomp$this.setLoading(false);
  });
}, handleError:function(errorJson) {
  var $jscomp$destructuring$var53 = errorJson || {};
  var error = $jscomp$destructuring$var53.error;
  var message = $jscomp$destructuring$var53.message;
  var details = $jscomp$destructuring$var53.details;
  this.connectionInfoPanelToolbar.add({xtype:'textfield', fieldLabel:'MESSAGE', value:[error, message].map(function(i) {
    return i || '';
  }).join(' - '), readOnly:true, margin:'0 5 0 5', flex:1});
  this.connectionInfoPanelToolbar.add({xtype:'button', text:'Details', errorJson:errorJson, handler:function(b) {
    flextable.Support.errorWindow(b.errorJson);
  }});
  this.dbManageComponents.map(function(c) {
    c.setDisabled(true);
  });
}});
Ext.define('flextable.plugin.detailWindow.Main', {extend:'Ext.panel.Panel', alias:'widget.flextablePlugin', mixins:['BpcCommon.mixin.PsPluginMixin', 'flextable.mixins.Component'], layout:'fit', padding:'5 5 5 5', idValue:undefined, legacy:false, flexTableParams:undefined, previewFileWrapperItemId:undefined, baseTitle:'', forceActiveTab:false, initComponent:function() {
  var $jscomp$this = this;
  this.iconCls = this.faIcon(this.getValueFromPluginConfiguration('iconCls') || 'fa-database');
  this.moduleId = this.getValueFromPluginConfiguration('moduleId') || undefined;
  var pTargetModuleId = this.getValueFromPluginConfiguration('instanceId', true);
  this.pluginParentInstanceId = pTargetModuleId;
  var rec = this.getValueFromPluginConfiguration('record', true);
  this.baseTitle = this.getValueFromPluginConfiguration('title');
  var sourceColumnId = this.getValueFromPluginConfiguration('sourceColumnId');
  var sourcePropertyReference = sourceColumnId || BpcCommon.Api.getSetting(pTargetModuleId, 'column_id');
  this.idValue = rec.get(sourcePropertyReference);
  this.loadGrid = this.idValue !== null;
  this.pluginSortColumn = this.getValueFromPluginConfiguration('sortColumn') || BpcCommon.Api.getSetting(this.moduleId, 'sortColumn');
  this.pluginSortDirection = this.getValueFromPluginConfiguration('sortDirection') || BpcCommon.Api.getSetting(this.moduleId, 'sortDirection');
  this.previewFileWrapperItemId = this.getValueFromPluginConfiguration('previewFileWrapperItemId');
  var forceActiveTab = this.getValueFromPluginConfiguration('forceActiveTab');
  if (forceActiveTab === true) {
    this.forceActiveTab = true;
  }
  var metaHidden = this.getValueFromPluginConfiguration('fileViewer_metaHidden');
  this.flextable = Ext.create({xtype:'flextableMain', isBpcModule:false, bpcPluginInstance:this, usedAsPlugin:true, moduleId:this.moduleId, fileViewerMetaHidden:metaHidden === true, showToolbars:false, idKey:Ext.isDefined(this.idValue) ? false : undefined, onTableCreated:this.onTableCreated.bind(this)});
  this.listeners = {added:function(c, owner) {
    var types = owner.getXTypes();
    types = types.split('/').map(function(t) {
      return t.toLowerCase();
    });
    if ($jscomp$this.forceActiveTab && types.indexOf('tabpanel') !== -1) {
      Ext.defer(function() {
        owner.setActiveTab(c);
      }, 1000);
      return;
    } else {
      var layout = owner.getLayout();
      if (layout && layout.config) {
        var $jscomp$destructuring$var54 = layout;
        var config = $jscomp$destructuring$var54.config;
        config = config || {};
        var $jscomp$destructuring$var55 = config;
        var type = $jscomp$destructuring$var55.type;
        type = type || '';
        if (type === 'hbox' || type === 'vbox') {
          c.setFlex(1);
          return;
        }
      }
      if (c.header) {
        c.header.hide();
      } else {
        c.header = false;
      }
    }
  }, beforedestroy:function(c) {
    try {
      $jscomp$this.destroyPlugin();
    } catch (e) {
      console.debug('unexpected error -  destroying ft plugin instance');
      console.debug(e);
    }
  }};
  this.items = [this.flextable];
  this.callParent(arguments);
  this.updateTitle();
}, destroyPlugin:function() {
  try {
    this.flextable.grid.store.getProxy().abort();
    this.removeAll();
    this.flextable = null;
  } catch (e) {
    console.debug('error destroying ft plugin instance');
    console.debug(e);
  }
}, onTableCreated:function() {
  var $jscomp$this = this;
  if (Ext.isDefined(this.idValue)) {
    if (this.loadGrid) {
      this.flextable.grid.changeExtraParams({id:this.idValue});
    }
    this.flextable.grid.flexContext = {processId:this.idValue};
  }
  this.integrationRestricted = BpcCommon.Api.getSetting(this.moduleId, 'onlyAsPlugin');
  if (this.integrationRestricted) {
    this.flextable.grid.changeExtraParams({pluginParentInstanceId:this.pluginParentInstanceId});
  }
  this.flextable.grid.store.on('load', function(s, records, success) {
    if ($jscomp$this.pluginSortColumn && $jscomp$this.pluginSortColumn.length) {
      s.sort({property:$jscomp$this.pluginSortColumn, direction:$jscomp$this.pluginSortDirection});
    }
    $jscomp$this.updateTitle(success ? records.length : 0);
    if (success) {
      if ($jscomp$this.previewFileWrapperItemId) {
        if ($jscomp$this.ownerCt) {
          var win = $jscomp$this.ownerCt.up('window');
          if (win) {
            var wrapper = win.down('#' + $jscomp$this.previewFileWrapperItemId);
            if (wrapper) {
              wrapper.removeAll();
              var storeData = $jscomp$this.getAttachments(records);
              storeData = storeData.map(function(o) {
                var newObj = Ext.apply({}, o.r.getData());
                if (newObj.id) {
                  delete newObj.id;
                }
                return newObj;
              });
              wrapper.add({xtype:'grid', store:Ext.create('Ext.data.Store', {data:storeData}), columns:$jscomp$this.flextable.grid.getActionColumnConfig($jscomp$this.moduleId).concat([{dataIndex:'REFERENZ', text:'Referenz', flex:1}, {dataIndex:'MIMETYPE', text:'Mime', flex:1}])});
            }
          }
        }
      }
    }
  });
  if (this.loadGrid) {
    this.flextable.load();
  } else {
    BpcCommon.Api.showNotification(flextable.Support.TR('FLEXTABLE_MESSAGE_WONT_LOAD_NULL'));
  }
}, getAttachments:function(records) {
  var $jscomp$this = this;
  records = records === void 0 ? [] : records;
  records = records.map(function(r) {
    return {r:r, attachment:$jscomp$this.flextable.grid.getAttachment(r)};
  }).filter(function(o) {
    return Ext.isDefined(o.attachment) && o.attachment !== null;
  });
  return records;
}, updateTitle:function(num) {
  num = num || 0;
  var prefix = this.baseTitle || 'FLEXTABLE';
  this.setTitle(prefix + ' ( ' + num + ' ) ');
}});
Ext.define('flextable.plugin.detailWindow.Wrapper', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Flextable Plugin', COMPONENT_XTYPE:'flextablePlugin', PLUGIN_ID:'flextable-detailwindow-plugin'}});
Ext.define('flextable.plugin.dynamicContent.Definition', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Flextable Dynamic Content', COMPONENT_XTYPE:'flextableDynamicContent', PLUGIN_ID:'flextable-dynamic-content-plugin'}});
Ext.define('flextable.plugin.dynamicContent.DynamicContent', {extend:'Ext.panel.Panel', alias:'widget.flextableDynamicContent', mixins:['BpcCommon.mixin.PsPluginMixin'], layout:'fit', instanceId:undefined, requestUrl:undefined, processIdKey:undefined, record:undefined, debugEnabled:false, initComponent:function() {
  this.hidden = true;
  var r = this.getValueFromPluginConfiguration('record', true);
  var instanceId = this.getValueFromPluginConfiguration('instanceId', true);
  var title = this.getValueFromPluginConfiguration('title');
  this.debugEnabled = this.getValueFromPluginConfiguration('debug');
  this.customId = this.getValueFromPluginConfiguration('customId') || 'customId';
  this.customProperties = this.getValueFromPluginConfiguration('customProperties') || {};
  var hookType = this.getValueFromPluginConfiguration('hookType') || 'FILE';
  hookType = hookType.trim().toLowerCase();
  this.title = title || 'Dynamic Content';
  this.hooks = {file:{}};
  this.callParent(arguments);
  if (this.tab) {
    this.tab.hide();
  }
  if (Ext.isDefined(instanceId) && Ext.isDefined(r) && this.hooks.hasOwnProperty(hookType)) {
    this.instanceId = instanceId;
    this.record = r;
    this.hookType = hookType;
    this.configurePlugin();
    this.loadDynamicContent();
    return;
  }
  this.showError(flextable.Support.TR('ERROR_CONFIG_WRONG'));
}, loadDynamicContent:function() {
  var $jscomp$this = this;
  if (this.debugEnabled) {
    this.getDebugData();
    return;
  }
  this.requestData().then(function(json) {
    $jscomp$this.handleWorkflowSuccessResponse(json);
  }, function(response) {
    $jscomp$this.showError('HANDLE');
  });
}, handleWorkflowSuccessResponse:function(json) {
  json = json || {};
  var $jscomp$destructuring$var56 = json;
  var success = $jscomp$destructuring$var56.success;
  var data = $jscomp$destructuring$var56.data;
  var message = $jscomp$destructuring$var56.message;
  if (success && success !== 'false') {
    data = data || [];
    this.showContent(data);
    return;
  }
  this.showError(Ext.valueFrom(message, flextable.Support.TR('ERROR_REQUEST_ERROR')));
}, getDebugData:function() {
  var $jscomp$this = this;
  fetch('bpc-fe-flextable/resources/examples/dynamic.json').then(function(r) {
    return r.json();
  }).then(function(json) {
    json = json || {};
    var $jscomp$destructuring$var57 = json;
    var success = $jscomp$destructuring$var57.success;
    var data = $jscomp$destructuring$var57.data;
    var message = $jscomp$destructuring$var57.message;
    if (success && success !== 'false') {
      data = data || [];
      $jscomp$this.showContent(data);
      return;
    }
    $jscomp$this.showError(Ext.valueFrom(message, flextable.Support.TR('ERROR_REQUEST_ERROR')));
  });
}, getSetting:function(settingName) {
  return BpcCommon.Api.getSetting(this.instanceId, settingName);
}, configurePlugin:function() {
  this.processIdKey = this.getSetting('column_id');
  this.processIdValue = Ext.String.htmlEncode(this.record.get(this.processIdKey));
  var endpoint = this.getSetting('inubit_vpsendpoint');
  var proxyId = this.getSetting('inubit_proxyId');
  var baseUrl = this.getSetting('inubit_baseUrl');
  this.requestUrl = BpcCommon.Api.getBackendUrl(proxyId) + baseUrl + endpoint;
}, getRequestParams:function() {
  return Ext.apply({}, {hookType:this.hookType, moduleId:this.instanceId, processId:this.processIdValue, customId:this.customId}, this.customProperties);
}, requestData:function() {
  var url = this.requestUrl;
  var params = this.getRequestParams();
  return Ext.Ajax.request({url:url, params:params, method:'POST'}).then(function(response) {
    return Ext.decode(response.responseText, true);
  }, function(response) {
    return response;
  });
}, showError:function(message) {
  this.removeAll();
  this.add({padding:'20 20 20 20', xtype:'displayfield', htmlEncode:true, value:message});
}, showContent:function(data) {
  var $jscomp$this = this;
  data = data === void 0 ? [] : data;
  this.removeAll();
  var wrapper = this.getHookTargetCmp();
  if (wrapper) {
    data.map(function(item) {
      wrapper.add($jscomp$this.getViewerForItem(item));
    });
  }
}, getViewerForItem:function(item) {
  var $jscomp$this = this;
  var $jscomp$destructuring$var58 = item;
  var mime = $jscomp$destructuring$var58.mime;
  var base64 = $jscomp$destructuring$var58.base64;
  var fileRaw = $jscomp$destructuring$var58.fileRaw;
  var dataUrl = $jscomp$destructuring$var58.dataUrl;
  var reference = $jscomp$destructuring$var58.reference;
  var loadOnClick = $jscomp$destructuring$var58.loadOnClick;
  var config = $jscomp$destructuring$var58.config;
  var component = $jscomp$destructuring$var58.component;
  var viewerPanel;
  if (component) {
    try {
      var cfg = Ext.apply({}, {xtype:component}, config || {});
      viewerPanel = Ext.create(cfg);
    } catch (e) {
      viewerPanel = Ext.create({xtype:'panel', title:'error', html:'something went wrong during cmp creation'});
    }
  } else {
    dataUrl = dataUrl || '';
    reference = reference || '';
    loadOnClick = [true, false].indexOf(loadOnClick) !== -1 ? loadOnClick : false;
    var decoded = '';
    var remoteFile = reference.length > 0;
    if (!remoteFile) {
      var raw = false;
      var fileData = '';
      if (dataUrl.startsWith('data:')) {
        var parts = dataUrl.split(';');
        var dataAndMime = parts[0].split(':');
        mime = dataAndMime[1];
        var encodingAndBase64 = parts[1].split(',');
        base64 = encodingAndBase64[1];
        if (encodingAndBase64.length === 1) {
          raw = true;
          fileData = encodingAndBase64[0];
        }
      } else {
        raw = true;
        fileData = fileRaw;
      }
      try {
        decoded = raw ? fileData : atob(base64);
      } catch (e$8) {
        decoded = '';
      }
    }
    var title = item.title || this.hookType || '';
    var params = this.getRequestParams();
    if (remoteFile) {
      params.reference = reference;
    }
    item = Ext.apply(item, {slim:true, file:decoded, remote:remoteFile, remoteFileReference:reference, remoteFileRequestData:{url:this.requestUrl, params:params}, remoteContentSourceComponent:this, meta:{mime:mime, directory:'', childid:undefined, processid:''}, record:undefined, fileSource:decoded, fileUrl:dataUrl});
    viewerPanel = flextable.file.getViewer('foo', item);
    viewerPanel.setTitle(title);
    viewerPanel.metaField.setVisible(false);
    viewerPanel.downloadButton.setDisabled(true);
    if (remoteFile && !loadOnClick) {
      viewerPanel.on('activate', function() {
        viewerPanel.debugEnabled = $jscomp$this.debugEnabled;
        viewerPanel.loadRemoteFile();
      });
    }
  }
  return viewerPanel;
}});
Ext.define('flextable.plugin.hooks.Base', {extend:'BpcCommon.plugin.HookContainer', context:undefined, autoInjectPlugins:false, pluginConfigurations:[], pluginComponentDefinitions:[], hidden:true, initComponent:function() {
  this.getPluginConfigurations();
  this.callParent(arguments);
}, getPluginConfigurations:function() {
  var pluginConfigs = [];
  try {
    this.setModuleContext();
    pluginConfigs = BpcCommon.Api.getPluginComponents(this, this.context) || [];
  } catch (e) {
    console.debug('error fetching plugins', e);
    pluginConfigs = [];
  }
  if (Ext.isArray(pluginConfigs)) {
    this.enrichPlugins(pluginConfigs);
  }
}, setModuleContext:function() {
  if (!this.context) {
    this.context = {};
  }
  this.context[BpcCommon.util.BpcSupport.versionStartsWith('4.1') ? 'baseModuleId' : 'moduleId'] = 'flextable';
  this.context[BpcCommon.util.BpcSupport.versionStartsWith('4.1') ? 'moduleId' : 'instanceId'] = this.moduleId;
}, getPluginDefinitions:function() {
  return (this.pluginComponentDefinitions || []).map(function(cfg) {
    return Object.assign({}, cfg);
  });
}, enrichPlugins:function(pluginComponents) {
  pluginComponents = pluginComponents === void 0 ? [] : pluginComponents;
  this.pluginComponentDefinitions = pluginComponents.map(function(obj) {
    return obj;
  });
}});
Ext.define('webtsm.components.plugin.hooks.DetailHook', {extend:'flextable.plugin.hooks.Base', alias:'widget.flextableDetailViewPopup', inheritableStatics:{NAME:'Flextable DetailView Popup', HOOK_ID:'flextable_detail_view_popup'}, moduleId:undefined});
Ext.define('flextable.plugin.hooks.GridActions', {extend:'flextable.plugin.hooks.Base', alias:'widget.flextableGridActionHook', inheritableStatics:{NAME:'Flextable Action Hook', HOOK_ID:'flextable_grid_actions', HOOK_LEVEL:'instance'}});
Ext.define('flextable.plugin.remoteLog.Definition', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Flextable Remote Log', COMPONENT_XTYPE:'flextableRemoteLog', PLUGIN_ID:'flextable-remote-log-plugin'}});
Ext.define('flextable.plugin.remoteLog.RemoteLog', {extend:'Ext.panel.Panel', alias:'widget.flextableRemoteLog', mixins:['BpcCommon.mixin.PsPluginMixin'], layout:'fit', instanceId:undefined, requestUrl:undefined, processIdKey:undefined, record:undefined, initComponent:function() {
  var $jscomp$this = this;
  var r = this.getValueFromPluginConfiguration('record', true);
  var instanceId = this.getValueFromPluginConfiguration('instanceId', true);
  var title = this.getValueFromPluginConfiguration('title');
  this.title = title || 'Details';
  this.callParent(arguments);
  if (Ext.isDefined(instanceId) && Ext.isDefined(r)) {
    this.instanceId = instanceId;
    this.record = r;
    this.configurePlugin();
    this.requestData().then(function(data) {
      data = data || {};
      if (String(data.success) === 'true') {
        $jscomp$this.showData(data);
        return;
      }
      $jscomp$this.showError(Ext.valueFrom(data.message, flextable.Support.TR('ERROR_REQUEST_ERROR')));
    }, function(response) {
      $jscomp$this.showError('HANDLE');
    });
    return;
  }
  this.showError(flextable.Support.TR('ERROR_CONFIG_WRONG'));
}, getSetting:function(settingName) {
  return BpcCommon.Api.getSetting(this.instanceId, settingName);
}, configurePlugin:function() {
  this.processIdKey = this.getSetting('column_id');
  this.processIdValue = Ext.String.htmlEncode(this.record.get(this.processIdKey));
  var endpoint = this.getSetting('inubit_vpsendpoint');
  var proxyId = this.getSetting('inubit_proxyId');
  var baseUrl = this.getSetting('inubit_baseUrl');
  this.requestUrl = BpcCommon.Api.getBackendUrl(proxyId) + baseUrl + endpoint;
}, requestData:function() {
  var url = this.requestUrl;
  var params = {request:'\x3croot\x3e\x3coperation\x3edetailData\x3c/operation\x3e\x3cprocessID\x3e' + this.processIdValue + '\x3c/processID\x3e\x3c/root\x3e'};
  return Ext.Ajax.request({url:url, params:params, method:'POST'}).then(function(response) {
    return Ext.decode(response.responseText, true);
  }, function(response) {
    return response;
  });
}, showError:function(message) {
  this.removeAll();
  this.add({padding:'20 20 20 20', xtype:'displayfield', htmlEncode:true, value:message});
}, createGridView:function(columns, fields, data) {
  data = data === void 0 ? [] : data;
  return Ext.create('Ext.grid.Panel', {flex:1, minWidth:20, columns:columns, store:Ext.create('Ext.data.Store', {fields:fields, data:data}), viewConfig:{enableTextSelection:true, enableColumnHide:true, enableColumnMove:false}});
}, showData:function(data) {
  data = data === void 0 ? {} : data;
  this.removeAll();
  var fields = [], columns = (data.columns || []).map(function(c) {
    var $jscomp$destructuring$var59 = c || {};
    var dataIndex = $jscomp$destructuring$var59.dataIndex;
    var text = $jscomp$destructuring$var59.text;
    var width = Ext.Number.from(c.width, 100);
    fields.push(c.dataIndex);
    return Ext.create('Ext.grid.column.Column', {dataIndex:dataIndex, text:text, width:width, hideable:false, sortable:false, align:c.align || 'left', cellAlign:c.cellAlign || 'right'});
  });
  var wrapper = Ext.create({xtype:'container', scrollable:true, layout:{type:'vbox', align:'stretchmax'}, items:[]});
  if ('right' in data.head) {
    wrapper.add({xtype:'container', anchor:'100%', layout:{type:'hbox', align:'stretch'}, padding:10, items:[{width:500, xtype:'displayfield', value:data.head.left}, {width:500, xtype:'displayfield', value:data.head.right}]});
  } else {
    wrapper.add({xtype:'displayfield', value:data.head.left});
  }
  wrapper.add(this.createGridView(columns, fields, data.data));
  this.add(wrapper);
}});
Ext.define('flextable.util.CSS', {singleton:true, createCustomStyling:function() {
  var $jscomp$this = this;
  [{clsName:'.flextable-error', clsDefinition:'{color: red !important;}'}, {clsName:'.flextable-cursor-pointer', clsDefinition:'{cursor: default !important;}'}].map(function(item) {
    var $jscomp$destructuring$var60 = item;
    var clsName = $jscomp$destructuring$var60.clsName;
    var clsDefinition = $jscomp$destructuring$var60.clsDefinition;
    $jscomp$this.create(clsName, clsDefinition);
  });
}, create:function(className, classDefinition) {
  Ext.util.CSS.createStyleSheet(className + classDefinition);
}});
Ext.define('flextable.util.Clipboard', {singleton:true, copyToClp:function(stringWithNewLines, cmp) {
  try {
    var myFluffyTextarea = document.createElement('textarea');
    myFluffyTextarea.innerHTML = stringWithNewLines;
    var parentElement = document.getElementById(cmp.getId());
    parentElement.appendChild(myFluffyTextarea);
    myFluffyTextarea.select();
    document.execCommand('copy');
    parentElement.removeChild(myFluffyTextarea);
    return true;
  } catch (e) {
    console.debug('copy error', e);
    return false;
  }
}});
Ext.define('flextable.util.Data', {singleton:true, domParser:undefined, doInit:function() {
  if (!this.domParser) {
    this.domParser = new DOMParser();
  }
}, parseXml:function(str, mime) {
  str = str === void 0 ? '' : str;
  mime = mime === void 0 ? 'text/xml' : mime;
  this.doInit();
  if (this.domParser) {
    return this.domParser.parseFromString(str, mime);
  }
  throw new Error('DOMParser does not exist');
}});
Ext.define('flextable.util.Database', {singleton:true, handleCapitalization:function(value, moduleId) {
  if (typeof value !== 'string' || typeof moduleId === 'undefined') {
    return value;
  }
  var lowerUpperAsIsProps = BpcCommon.Api.getSetting(moduleId, 'lowerUpperAsIsProps') || null;
  if (lowerUpperAsIsProps !== null) {
    if (lowerUpperAsIsProps.toLowerCase() === 'lower') {
      value = value.toLowerCase();
    } else if (lowerUpperAsIsProps.toLowerCase() === 'upper') {
      value = value.toUpperCase();
    } else {
    }
  }
  return value;
}});
Ext.define('flextable.util.Date', {singleton:true, autoDateParser:function(v) {
  var format, formatInput, date;
  var autoParseMappings = BpcCommon.Api.getSetting('flextable', 'date_autoParseMappings') || {};
  if (typeof v === 'number') {
    v = '' + v;
    if (v.length === 10) {
      formatInput = 'timestamp';
    } else if (v > 10) {
      formatInput = 'time';
    }
    if (formatInput) {
      format = autoParseMappings[formatInput];
    }
    format = format || BpcCommon.Api.getSetting('flextable', 'date_defaultFormat');
    date = formatInput ? Ext.Date.parse(v, formatInput) : Ext.Date.parse(v);
    if (Ext.isDate(date)) {
      return Ext.Date.format(date, format);
    }
  } else if (typeof v === 'string') {
    return this.stringDateParser(v, format);
  }
}, stringDateParser:function(v, format) {
  format = format || BpcCommon.Api.getSetting('flextable', 'date_defaultFormat');
  var splitted = v.split('+');
  if (splitted.length === 2) {
    var tzArray = splitted[1].split(':');
    if (tzArray[0].length === 1) {
      tzArray[0] = '0' + tzArray[0];
    }
    var timeZone = tzArray.join(':');
    var newDateString = splitted[0].trim() + '+' + timeZone;
    newDateString = newDateString.trim();
    var date2 = Ext.Date.parse(newDateString);
    if (date2) {
      return Ext.Date.format(date2, format);
    }
  }
}});
Ext.define('flextable.util.Dev', {singleton:true, getModuleNameFromClassName:function() {
  var classNameParts = this.$className.split('.');
  return classNameParts[0];
}, showMissingTranslations:function() {
  var store = flextable.util.Store.newLocalStore();
  var map = flextable.Support.getMissingTranslations() || {};
  var data = Object.keys(map).map(function(key) {
    return {key:key, de:'', en:''};
  });
  store.removeAll();
  store.add(data);
  var grid = {xtype:'grid', store:store, selModel:'cellmodel', plugins:{cellediting:{clicksToEdit:1}}, tbar:[{xtype:'tbfill'}, {text:'Export', iconCls:flextable.Support.faIcon('fa-file-export'), handler:function(b) {
    var s = b.up('grid').store;
    var exportData = [];
    s.each(function(r) {
      var $jscomp$destructuring$var61 = r.getData();
      var key = $jscomp$destructuring$var61.key;
      var de = $jscomp$destructuring$var61.de;
      var en = $jscomp$destructuring$var61.en;
      exportData.push({key:key, de:de, en:en});
    });
    var items = [];
    var de_data = exportData.map(function(item) {
      var $jscomp$destructuring$var62 = item;
      var key = $jscomp$destructuring$var62.key;
      var de = $jscomp$destructuring$var62.de;
      var value = de || '';
      return '"' + key + '" : "' + value + '"';
    });
    var en_data = exportData.map(function(item) {
      var $jscomp$destructuring$var63 = item;
      var key = $jscomp$destructuring$var63.key;
      var en = $jscomp$destructuring$var63.en;
      var value = en || '';
      return '"' + key + '" : "' + value + '"';
    });
    items.push({title:'de', xtype:'panel', layout:'fit', items:[{xtype:'textarea', grow:true, fieldLabel:'MISSING', value:de_data.join(',\n')}]});
    items.push({title:'de', xtype:'panel', layout:'fit', items:[{xtype:'textarea', grow:true, fieldLabel:'MISSING', value:en_data.join(',\n')}]});
    var windowCfg = {xtype:'window', layout:'fit'};
    windowCfg.title = 'MISSING_TRANSLATIONS';
    windowCfg.iconCls = flextable.Support.faIcon('fa-info');
    windowCfg.items = [{xtype:'tabpanel', items:items}];
    Ext.create(windowCfg).show();
  }}], columns:['key', 'de', 'en'].map(function(dataIndex) {
    var c = {dataIndex:dataIndex, text:dataIndex, flex:1};
    if (dataIndex !== 'key') {
      c.editor = {completeOnEnter:false, field:{xtype:'textfield', allowBlank:false}};
    }
    return c;
  })};
  var windowConfig = Ext.apply({xtype:'window', layout:'fit'}, {title:flextable.Support.TR('MISSING_TRANSLATIONS'), iconCls:flextable.Support.faIcon('fa-plus'), items:[grid], width:'80%', height:'80%'});
  return Ext.create(windowConfig).show();
}});
Ext.define('flextable.util.Store', {singleton:true, newLocalStore:function(data) {
  data = data === void 0 ? [] : data;
  return Ext.create('Ext.data.Store', {data:data});
}, responseDataTransformer:function() {
  return function(data) {
    data = data || {};
    var logNames = Object.keys(data);
    var $jscomp$destructuring$var64 = $jscomp.makeIterator(logNames);
    var logName = $jscomp$destructuring$var64.next().value;
    if (logName) {
      var logData = data[logName] || {};
      var $jscomp$destructuring$var65 = logData;
      var total = $jscomp$destructuring$var65.total;
      var row = $jscomp$destructuring$var65.row;
      return {total:total, items:row, meta:{logName:logName}};
    }
    return data;
  };
}, startParam:'startIndex', limitParam:'noOfItems', pageSize:100, prepareForIS:function(store) {
  var proxy = store.getProxy();
  proxy.getReader().setTransform(this.responseDataTransformer());
  proxy.setStartParam(this.startParam);
  proxy.setLimitParam(this.limitParam);
  store.setPageSize(this.pageSize);
}});
Ext.define('flextable.view.Main', {extend:'Ext.panel.Panel', alias:'widget.flextableMain', mixins:['flextable.mixins.Component'], layout:'fit', header:false, moduleId:undefined, idKey:undefined, showToolbars:true, initColumns:undefined, isBpcModule:true, usedAsPlugin:false, fileViewerMetaHidden:undefined, integrationRestricted:false, initComponent:function() {
  var $jscomp$this = this;
  var idKey = this.idKey === false ? undefined : this.idKey || BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.id);
  if (this.isBpcModule) {
    this.integrationRestricted = BpcCommon.Api.getSetting(this.moduleId, 'onlyAsPlugin');
    this.addBpcModuleFeatures();
  }
  this.callParent(arguments);
  if (this.integrationRestricted) {
    this.add(this.messagePanel('INTEGRATION_RESTRICTED', 'INTEGRATION_RESTRICTED_AS_PLUGIN_ONLY'));
    return;
  }
  this.bootModuleInstance().then(function(config) {
    if (config) {
    }
    $jscomp$this.createFtViews(idKey);
  });
}, bootModuleInstance:function() {
  return flextable.Support.preloadPluginModules(this.moduleId);
}, createFtViews:function(idKey) {
  this.grid = this.isDatabaseInstance() ? this.createTable(idKey) : this.createHttpTable();
  this.add(this.grid);
  this.onTableCreated();
  this.load();
}, createTable:function(idKey) {
  return Ext.create({xtype:'flextableGrid', moduleId:this.moduleId, moduleInstance:this, idKey:idKey, mode:this.idKey === false ? 'details' : undefined});
}, createHttpTable:function() {
  return Ext.create({xtype:'flextableHttpGrid', moduleId:this.moduleId, moduleInstance:this});
}, onTableCreated:function() {
}, addBpcModuleFeatures:function() {
  this.bpcModuleHeader = Ext.createByAlias('widget.flextableModuleHeader', {moduleId:this.moduleId, moduleInstance:this});
}, load:function() {
  if (!this.usedAsPlugin) {
    this.grid.store.load();
  }
}, getColumn:function(dataIndex) {
  return this.grid.getColumns().filter(function(col) {
    return col.dataIndex === dataIndex;
  }).map(function(col) {
    return {text:col.text || col.header || '', dataIndex:dataIndex, renderer:col.renderer || undefined};
  });
}});
Ext.define('flextable.view.ModuleHeader', {extend:'Ext.container.Container', alias:'widget.flextableModuleHeader', mixins:['flextable.mixins.Component'], layout:{type:'hbox', align:'stretch'}, moduleId:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.items = [{xtype:'toolbar', flex:1, items:[{handler:function() {
    var columns = $jscomp$this.moduleInstance.grid.getColumns().map(function(c) {
      var $jscomp$destructuring$var66 = c;
      var flex = $jscomp$destructuring$var66.flex;
      var dataIndex = $jscomp$destructuring$var66.dataIndex;
      var text = $jscomp$destructuring$var66.text;
      var menuText = $jscomp$destructuring$var66.menuText;
      var width = $jscomp$destructuring$var66.width;
      var renderer = $jscomp$destructuring$var66.renderer;
      var header = $jscomp$destructuring$var66.header;
      return {flex:flex, dataIndex:dataIndex, text:text, menuText:menuText, width:width, renderer:renderer, header:header};
    });
    console.log(columns);
    var w = Ext.create('Ext.window.Window', {title:'COL_CONFIG', height:document.body.clientHeight * 0.8, width:document.body.clientWidth * 0.6, layout:'fit', iconCls:flextable.Support.faIcon('columns' || 'fa-info')});
  }, tooltip:this.TR('CHANGE_COLUMN_CONFIGURATION'), iconCls:this.faIcon('columns'), hidden:!flextable.Support.isDeveloper()}, {xtype:'tbfill'}, {handler:this.moduleInstance.load.bind(this.moduleInstance), tooltip:this.TR('REFRESH'), iconCls:this.faIcon('fa-sync')}]}];
  this.callParent(arguments);
}});
